#ifndef PTABS_H
#define PTABS_H

/* generated constants */


#define BASE		1

#define PAEOF		1

#define STPROD		68



/* generated tables which are not */
/* changable by optimization      */


static unsigned char conncode[]  =  {

  10,  11,  12,  13,  14,  15,  16,  17,  18,  19,  20,  21,  22,  23,  24,  25,
  26,  27,  28,  29,  30,  31,  32,  33,  34,  35,  36,  37,  38,  39,  40,  41,
  42,  43,  44,   0,  45,  46,  47,  48,  49,  50,  51,  52,  53,  54,  55,  56,
  57,  58,  59,  60,  61,  62,  63,  64,  65,  66,  67,  68,  69,  70,  71,  72,
  73,  74,  75,  76,   0 
};



static unsigned char lhs [] =  {

      0,     2,     1,     3,     3,     7,     8,     8,     9,     4,     4
,     4,     5,    11,    11,    12,    12,    13,    13,    14,    15,    15
,    16,     6,     6,    17,    18,    18,    19,    22,    22,    23,    23
,    25,    24,    24,    27,    27,    29,    31,    31,    31,    30,    30
,    32,    32,    32,    32,    36,    34,    33,    35,    35,    21,    10
,    10,    39,    40,    20,    20,    28,    28,    26,    26,    38,    38
,    37,    37,    41
};



static unsigned char len [] =  {

      2,     0,     4,     2,     0,     1,     0,     2,     4,     3,     1
,     0,     3,     2,     0,     2,     0,     2,     0,     1,     0,     2
,     2,     5,     3,     1,     4,     0,     1,     0,     2,     4,     6
,     1,     3,     1,     3,     1,     1,     1,     1,     1,     0,     2
,     1,     1,     3,     2,     3,     2,     2,     1,     1,     1,     1
,     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,     1
,     1,     1,     2
};



static unsigned char cont[]  =  {

  10,  18,  10,   1,   1,  18,  10,  18,  10,  10,   3,  20,  11,  11,  11,  11,
   1,   3,  20,  20,  26,  24,  24,   5,  18,  26,  18,  26,  26,  26,  18,  14,
  16,  11,  20,  26,   5,  11,   5,  18,  10,  18,  10,   5,   5,  10,   3,   4,
   5 
};



static char terminf[]  =  {

0x00,0x00,0x00,0x00,0x00,0x00,0x00,
};



/* macro for accessing the terminal-table */
/* the Row Displacement Scheme is performed for the terminal-table */

#define SIGMAP(row , col) (sigmap[row][col >> 3] >> (col & 0x0007)) & 0x01

#define GET_TTABENTRY( RorS, Act, term ) \
	{\
	  register    U_SHORT j;\
	  j = conv[ term ]; \
	  if( SIGMAP( sigrowind[RorS], sigcolind[j] ) )  { \
	    j = ttab[ trowptr[RorS] + j ]; \
	    Act  = j & ACTIONMASK; \
	    RorS = j & OPERANDMASK; \
	  }\
	  else \
	    Act  = 0; \
	}

static unsigned char conv [] =  {

      0,     0,     1,     2,     3,     4,     5,     6,     7,     8,     9
,    10,    11,    12,    13,    14,    15,    16,    17,    18,    19,    20
,    21,    22,    23,    24,    25,    26,    27
};



static unsigned char sigrowind [] =  {

      0,     1,     2,     3,     3,     4,     5,     6,     7,     8,     9
,    10,    11,    12,    13,    11,    11,    14,    15,    10,    16,    17
,    18,    19,    20,    17,    20,    21,    22,    23,    24,    25,    26
,    12,    10,    16,    19,    12,    27,    28,    29,    30,     6,    27
,    27,     1,    14,    31,    27
};



static unsigned char sigcolind [] =  {

      0,     1,     2,     3,     4,     5,     6,     7,     8,     9,    10
,    11,    12,    13,    12,    14,    12,    15,    16,    16,    17,    17
,    18,    18,    12,    12,    19,    19
};



static unsigned char sigmap[][3] =  {

 0xe2,0x03,0x00,0xe0,0x87,0x00,0xe0,0x03,0x00,0x01,0x00,0x00,0xc0,0x87,0x00,0xc0
,0x03,0x00,0x80,0x87,0x00,0x80,0x03,0x00,0x00,0x02,0x00,0x05,0x0c,0x00,0x00,0x00
,0x01,0x01,0x04,0x00,0x00,0x04,0x00,0x01,0x0c,0x00,0x04,0x00,0x00,0x04,0x00,0x01
,0x10,0x94,0x06,0x10,0xf4,0x06,0x10,0x60,0x06,0x10,0x00,0x04,0x00,0x84,0x00,0x00
,0xd4,0x06,0x00,0xb4,0x06,0x10,0xf4,0x0e,0x00,0x80,0x00,0x00,0x20,0x04,0x00,0x40
,0x04,0x10,0x00,0x00,0x00,0x87,0x00,0x00,0x03,0x00,0x00,0x86,0x00,0x08,0x00,0x00

};



static unsigned char trowptr[] = {

     0,     5,    11,     0,     2,    17,    22,    28,    32,    12,    42,
    14,    46,    33,    42,    46,    47,     1,    46,    14,    56,    78,
    92,    63,    17,    56,    17,    56,    56,   106,    32,    61,    36,
    40,    14,    56,   102,    40,     0,    28,    46,    28,   127,    57,
    58,   133,    61,    72,    83 
};



static unsigned short ttab [] =  {

 0x2001,0x1001,0x8000,0x1021,0x401a,0x2004,0x2004,0x2004,0x2004,0x2004,0x2006
,0x2006,0x2006,0x2006,0x2006,0x2006,0x1005,0x200b,0x200b,0x200b,0x200b,0x100a
,0x2006,0x200a,0x200a,0x200a,0x200a,0x4038,0x1007,0x200e,0x200e,0x200e,0x403a
,0x403b,0x4039,0x2014,0x2014,0x2014,0x2014,0x1027,0x2010,0x2010,0x201b,0x4019
,0x100d,0x2014,0x201d,0x201c,0x2021,0x4032,0x4035,0x4030,0x201b,0x100b,0x1029
,0x2012,0x201d,0x1012,0x403e,0x403f,0x202a,0x4016,0x4009,0x102f,0x2035,0x2035
,0x202a,0x401f,0x202a,0x202a,0x202a,0x202a,0x202a,0x202a,0x402e,0x1030,0x202a
,0x202a,0x202a,0x202a,0x202a,0x202a,0x2026,0x403e,0x403f,0x403e,0x403f,0x4008
,0x4038,0x0000,0x101c,0x2026,0x101b,0x2026,0x101e,0x4039,0x2023,0x0000,0x2026
,0x2026,0x2026,0x2026,0x4040,0x4041,0x0000,0x2023,0x4020,0x2023,0x0000,0x0000
,0x2027,0x0000,0x403c,0x403d,0x2023,0x2023,0x2027,0x0000,0x2027,0x2027,0x2027
,0x2027,0x2027,0x2027,0x403e,0x403f,0x2027,0x2027,0x2027,0x2027,0x2027,0x2027
,0x4042,0x4043,0x2013,0x2013,0x2013,0x4038,0x2005,0x2005,0x2005,0x2005,0x2005
,0x4038,0x4039,0x0000,0x0000,0x0000,0x0000,0x0000,0x4039
};



/* macro for accessing the nonterminal-table */
/* the Row Displacement Scheme is performed for the nonterminal-table */

#define GET_NTABENTRY(RorS, Act, State, lhsnt) \
	{\
	  register      U_SHORT j;\
	  j = ntab[ nrowptr[State] + lhsnt ]; \
	  Act = j & ACTIONMASK; \
	  RorS = j & OPERANDMASK; \
	}

static unsigned char nrowptr[] = {

     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     3,     4,     4,     0,     0,     4,     4,    10,
     2,     6,    25,     7,    28,    27,    31,    10,     0,     6,     6,
    31,    33,    42,     6,    38,     0,    48,     0,    59,    60,     0,
     0,    68,     0,     0,     0 
};



static unsigned short ntab [] =  {

 0x6004,0x6003,0x9000,0x6002,0x6006,0x6009,0x9002,0x9003,0x602d,0x0000,0x602c
,0x6008,0x6028,0x900c,0x900d,0x602a,0x0000,0x600e,0x600c,0x9018,0x6025,0x600f
,0x6010,0x9017,0x6014,0x6013,0x6010,0x901e,0x6017,0x6011,0x6019,0x6016,0x6018
,0x9025,0x6015,0x9022,0x9024,0x6015,0x9031,0x9036,0x9037,0x902b,0x601d,0x9028
,0x9029,0x902c,0x902d,0x902f,0x601a,0x9033,0x9034,0x6020,0x6022,0x6023,0x6016
,0x601f,0x9025,0x6015,0x6016,0x6026,0x9025,0x6015,0x900f,0x602a,0x9036,0x9037
,0x6024,0x9036,0x9037,0x6016,0x602b,0x9025,0x6015,0x9011,0x602a,0x0000,0x9015
,0x9007,0x602e,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000
,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000
,0x9036,0x9037,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x9036,0x9037
};





#endif

static	char *state2terms[] = {
	(char *)NULL,	/* state 1 */
	(char *)NULL,	/* state 2 */
	"\"$STOP\", \"$SEPA\", \"$BRACKET\", \"$SKIP\" or \"$GRAMMAR\"",	/* state 3 */
	"\"EOF\"",	/* state 4 */
	"\"EOF\"",	/* state 5 */
	(char *)NULL,	/* state 6 */
	"\"$SEPA\", \"$BRACKET\", \"$SKIP\" or \"$GRAMMAR\"",	/* state 7 */
	"\"$BRACKET\", \"$SKIP\", \"$GRAMMAR\", \"NAME\" or \"STRING\"",	/* state 8 */
	"\"$BRACKET\", \"$SKIP\" or \"$GRAMMAR\"",	/* state 9 */
	"\"$GRAMMAR\"",	/* state 10 */
	"\"=\", \"<$START_SYMBOL>\", \"EOF\" or \"NAME\"",	/* state 11 */
	"\"::=\" or \":\"",	/* state 12 */
	"\"EOF\" or \"NAME\"",	/* state 13 */
	"\"NAME\"",	/* state 14 */
	"\"<$START_SYMBOL>\", \"EOF\" or \"NAME\"",	/* state 15 */
	"\"EOF\" or \"NAME\"",	/* state 16 */
	"\"NAME\" or \"EOF\"",	/* state 17 */
	"\"=\"",	/* state 18 */
	"\":\", \"::=\" or \"=\"",	/* state 19 */
	"\"::=\" or \":\"",	/* state 20 */
	(char *)NULL,	/* state 21 */
	(char *)NULL,	/* state 22 */
	(char *)NULL,	/* state 23 */
	"\".\", \"||\" or \"//\"",	/* state 24 */
	"\"STRING\" or \"NAME\"",	/* state 25 */
	(char *)NULL,	/* state 26 */
	"\"STRING\" or \"NAME\"",	/* state 27 */
	(char *)NULL,	/* state 28 */
	(char *)NULL,	/* state 29 */
	(char *)NULL,	/* state 30 */
	"\"STRING\"",	/* state 31 */
	"\")\", \"||\" or \"//\"",	/* state 32 */
	"\"]\", \"||\" or \"//\"",	/* state 33 */
	"\"NAME\"",	/* state 34 */
	"\"::=\" or \":\"",	/* state 35 */
	(char *)NULL,	/* state 36 */
	"\".\", \"||\" or \"//\"",	/* state 37 */
	"\"NAME\"",	/* state 38 */
	"\".\"",	/* state 39 */
	"\"$SKIP\", \"$GRAMMAR\", \"NAME\" or \"STRING\"",	/* state 40 */
	"\"$SKIP\" or \"$GRAMMAR\"",	/* state 41 */
	"\"$GRAMMAR\", \"NAME\" or \"STRING\"",	/* state 42 */
	"\"STRING\", \"NAME\", \"$BRACKET\", \"$SKIP\" or \"$GRAMMAR\"",	/* state 43 */
	"\".\"",	/* state 44 */
	"\".\"",	/* state 45 */
	(char *)NULL,	/* state 46 */
	"\"=\"",	/* state 47 */
	"\"CARDINAL\"",	/* state 48 */
	"\".\"",	/* state 49 */
	(char *)NULL
}; /* of array state2terms[] */
