
/* definition of tree node structure */

#ifndef NODE_H
#define NODE_H
#include "err.h"
#include "nodeptr.h" /* defines NODEPTR */
#include "HEAD.h"

#ifdef MONITOR
#define _NODECOMMON int _prod; POSITION _coord;
#else
#define _NODECOMMON int _prod;
#endif
struct NODEPTR_struct {
        _NODECOMMON
#ifdef __cplusplus
        void* operator new(size_t size);
#endif
};

typedef struct _TSoperation_sig* _TSPoperation_sig;
typedef struct _TSiddef* _TSPiddef;
typedef struct _TSoperation_block* _TSPoperation_block;
typedef struct _TStypeid* _TSPtypeid;
typedef struct _TSspec* _TSPspec;
typedef struct _TSaspects* _TSPaspects;
typedef struct _TSaspect_stmt* _TSPaspect_stmt;
typedef struct _TSsigs* _TSPsigs;
typedef struct _TSevent_sig* _TSPevent_sig;
typedef struct _TSexport* _TSPexport;
typedef struct _TSevent_block* _TSPevent_block;
typedef struct _TSattr* _TSPattr;
typedef struct _TSsig* _TSPsig;
typedef struct _TSparam* _TSPparam;
typedef struct _TStranslation_sig* _TSPtranslation_sig;
typedef struct _TSiduse* _TSPiduse;
typedef struct _TSoptattrs* _TSPoptattrs;
typedef struct _TSattrs* _TSPattrs;
typedef struct _TSoptparams* _TSPoptparams;
typedef struct _TSparams* _TSPparams;
typedef struct _TPoperation_sig1* _TPPoperation_sig1;
typedef struct _TPoperation_sig2* _TPPoperation_sig2;
typedef struct _TPrule_000* _TPPrule_000;
typedef struct _TPrule_001* _TPPrule_001;
typedef struct _TPrule_002* _TPPrule_002;
typedef struct _TPrule_003* _TPPrule_003;
typedef struct _TPrule_004* _TPPrule_004;
typedef struct _TPrule_005* _TPPrule_005;
typedef struct _TPrule_006* _TPPrule_006;
typedef struct _TPrule_007* _TPPrule_007;
typedef struct _TPrule_008* _TPPrule_008;
typedef struct _TPrule_009* _TPPrule_009;
typedef struct _TPrule_010* _TPPrule_010;
typedef struct _TPrule_011* _TPPrule_011;
typedef struct _TPrule_012* _TPPrule_012;
typedef struct _TPrule_013* _TPPrule_013;
typedef struct _TPrule_014* _TPPrule_014;
typedef struct _TPrule_015* _TPPrule_015;
typedef struct _TPrule_016* _TPPrule_016;
typedef struct _TPrule_1* _TPPrule_1;
typedef struct _TPrule_2* _TPPrule_2;
typedef struct _TPrule_3* _TPPrule_3;
typedef struct _TPrule_4* _TPPrule_4;
typedef struct _TPrule_5* _TPPrule_5;
typedef struct _TPrule_6* _TPPrule_6;
typedef struct _TPrule_7* _TPPrule_7;
typedef struct _TPrule_8* _TPPrule_8;
typedef struct _TPrule_9* _TPPrule_9;
typedef struct _TPrule_10* _TPPrule_10;
typedef struct _TPrule_11* _TPPrule_11;
typedef struct _TPrule_12* _TPPrule_12;
typedef struct _TPrule_13* _TPPrule_13;

struct _TSoperation_sig
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSiddef
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATSym;
DefTableKey _ATKey;
PTGNode _ATidcode;
};

struct _TSoperation_block
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
Environment _ATExportEnv;
};

struct _TStypeid
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSspec
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
Environment _ATTypeEnv;
Environment _ATExportEnv;
};

struct _TSaspects
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSaspect_stmt
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSsigs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSevent_sig
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSexport
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATexported;
};

struct _TSevent_block
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
Environment _ATExportEnv;
};

struct _TSattr
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSsig
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSparam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TStranslation_sig
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSiduse
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATKey;
};

struct _TSoptattrs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSattrs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSoptparams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSparams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPoperation_sig1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPiddef _desc1;
_TSPoperation_block _desc2;
int _ATTERM_2;
};

struct _TPoperation_sig2
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPiddef _desc1;
_TSPoperation_block _desc2;
_TSPtypeid _desc3;
POSITION _AT_pos;
int _ATTERM_2;
};

struct _TPrule_000
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPaspect_stmt _desc1;
};

struct _TPrule_001
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPaspects _desc1;
_TSPaspect_stmt _desc2;
};

struct _TPrule_002
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPsig _desc1;
};

struct _TPrule_003
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPsigs _desc1;
_TSPsig _desc2;
};

struct _TPrule_004
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPevent_sig _desc1;
};

struct _TPrule_005
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPoperation_sig _desc1;
};

struct _TPrule_006
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPtranslation_sig _desc1;
};

struct _TPrule_007
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
Environment _ATExportEnv;
_TSPoptattrs _desc1;
};

struct _TPrule_008
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_009
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPattrs _desc1;
};

struct _TPrule_010
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPattr _desc1;
};

struct _TPrule_011
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPattrs _desc1;
_TSPattr _desc2;
};

struct _TPrule_012
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
Environment _ATExportEnv;
_TSPoptparams _desc1;
int _AT_line;
};

struct _TPrule_013
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_014
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPparams _desc1;
};

struct _TPrule_015
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPparam _desc1;
};

struct _TPrule_016
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPparams _desc1;
_TSPparam _desc2;
};

struct _TPrule_1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
Environment _ATTypeEnv;
Environment _ATExportEnv;
_TSPaspects _desc1;
};

struct _TPrule_2
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPiddef _desc1;
_TSPsigs _desc2;
};

struct _TPrule_3
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPiddef _desc1;
_TSPexport _desc2;
_TSPevent_block _desc3;
int _ATTERM_1;
};

struct _TPrule_4
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATexported;
};

struct _TPrule_5
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATexported;
};

struct _TPrule_6
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPtypeid _desc1;
_TSPiddef _desc2;
int _ATTERM_1;
};

struct _TPrule_7
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATTERM_1;
};

struct _TPrule_8
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATTERM_1;
};

struct _TPrule_9
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPtypeid _desc1;
_TSPiddef _desc2;
};

struct _TPrule_10
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPiddef _desc1;
_TSPiduse _desc2;
int _ATTERM_2;
};

struct _TPrule_11
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATKey;
int _ATTERM_1;
};

struct _TPrule_12
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATSym;
DefTableKey _ATKey;
PTGNode _ATidcode;
};

struct _TPrule_13
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATTERM_1;
};

#undef _NODECOMMON
#endif
