
/* definition of tree node structure */

#ifndef NODE_H
#define NODE_H
#include "err.h"
#include "nodeptr.h" /* defines NODEPTR */
#include "HEAD.h"

#ifdef MONITOR
#define _NODECOMMON int _prod; POSITION _coord;
#else
#define _NODECOMMON int _prod;
#endif
struct NODEPTR_struct {
        _NODECOMMON
#ifdef __cplusplus
        void* operator new(size_t size);
#endif
};

typedef struct _TSAG* _TSPAG;
typedef struct _TSSpecs* _TSPSpecs;
typedef struct _TSSymSpec* _TSPSymSpec;
typedef struct _TSSymClass* _TSPSymClass;
typedef struct _TSSymSpecIds* _TSPSymSpecIds;
typedef struct _TSAttrDefsOpt* _TSPAttrDefsOpt;
typedef struct _TSSymSpecId* _TSPSymSpecId;
typedef struct _TSSymComp* _TSPSymComp;
typedef struct _TSInheritOpt* _TSPInheritOpt;
typedef struct _TSCompPart* _TSPCompPart;
typedef struct _TSAttrDef* _TSPAttrDef;
typedef struct _TSAttrDefIds* _TSPAttrDefIds;
typedef struct _TSTypeId* _TSPTypeId;
typedef struct _TSClass* _TSPClass;
typedef struct _TSAttrDefId* _TSPAttrDefId;
typedef struct _TSAttr* _TSPAttr;
typedef struct _TSSymOcc* _TSPSymOcc;
typedef struct _TSDefAttr* _TSPDefAttr;
typedef struct _TSLocAttr* _TSPLocAttr;
typedef struct _TSRemoteAttr* _TSPRemoteAttr;
typedef struct _TSSymId* _TSPSymId;
typedef struct _TSIndex* _TSPIndex;
typedef struct _TSAttrComp* _TSPAttrComp;
typedef struct _TSExpressionDep* _TSPExpressionDep;
typedef struct _TSLoop* _TSPLoop;
typedef struct _TSComputation* _TSPComputation;
typedef struct _TSBottomUpOpt* _TSPBottomUpOpt;
typedef struct _TSAttrSpec* _TSPAttrSpec;
typedef struct _TSAttrNames* _TSPAttrNames;
typedef struct _TSChainSpec* _TSPChainSpec;
typedef struct _TSAttrName* _TSPAttrName;
typedef struct _TSRuleSpecId* _TSPRuleSpecId;
typedef struct _TSRuleSpec* _TSPRuleSpec;
typedef struct _TSProduction* _TSPProduction;
typedef struct _TSExpression* _TSPExpression;
typedef struct _TSRhsAttrs* _TSPRhsAttrs;
typedef struct _TSParamsOpt* _TSPParamsOpt;
typedef struct _TSParams* _TSPParams;
typedef struct _TSParam* _TSPParam;
typedef struct _TSDepClause* _TSPDepClause;
typedef struct _TSDependence* _TSPDependence;
typedef struct _TSDepAttr* _TSPDepAttr;
typedef struct _TSDepAttrs* _TSPDepAttrs;
typedef struct _TSRemoteExpression* _TSPRemoteExpression;
typedef struct _TSRemoteClause* _TSPRemoteClause;
typedef struct _TSSubtree* _TSPSubtree;
typedef struct _TSShield* _TSPShield;
typedef struct _TSExpandOpt* _TSPExpandOpt;
typedef struct _TSShieldClause* _TSPShieldClause;
typedef struct _TSShieldSym* _TSPShieldSym;
typedef struct _TSInheritSym* _TSPInheritSym;
typedef struct _TSSyntId* _TSPSyntId;
typedef struct _TSSyntUnits* _TSPSyntUnits;
typedef struct _TSSyntUnit* _TSPSyntUnit;
typedef struct _TSAlts* _TSPAlts;
typedef struct _TSAlt* _TSPAlt;
typedef struct _TSSpec* _TSPSpec;
typedef struct _TSAttrDefs* _TSPAttrDefs;
typedef struct _TSComputations* _TSPComputations;
typedef struct _TSRemoteAttrs* _TSPRemoteAttrs;
typedef struct _TSShieldSyms* _TSPShieldSyms;
typedef struct _TSInheritSyms* _TSPInheritSyms;
typedef struct _TPrule_000* _TPPrule_000;
typedef struct _TPrule_001* _TPPrule_001;
typedef struct _TPrule_002* _TPPrule_002;
typedef struct _TPrule_003* _TPPrule_003;
typedef struct _TPrule_004* _TPPrule_004;
typedef struct _TPrule_005* _TPPrule_005;
typedef struct _TPrule_006* _TPPrule_006;
typedef struct _TPrule_007* _TPPrule_007;
typedef struct _TPrule_008* _TPPrule_008;
typedef struct _TPrule_009* _TPPrule_009;
typedef struct _TPrule_010* _TPPrule_010;
typedef struct _TPrule_011* _TPPrule_011;
typedef struct _TPrule_012* _TPPrule_012;
typedef struct _TPrule_013* _TPPrule_013;
typedef struct _TPrule_014* _TPPrule_014;
typedef struct _TPrule_015* _TPPrule_015;
typedef struct _TPrule_016* _TPPrule_016;
typedef struct _TPrule_017* _TPPrule_017;
typedef struct _TPrule_018* _TPPrule_018;
typedef struct _TPrule_019* _TPPrule_019;
typedef struct _TPrule_020* _TPPrule_020;
typedef struct _TPrule_021* _TPPrule_021;
typedef struct _TPrule_022* _TPPrule_022;
typedef struct _TPrule_023* _TPPrule_023;
typedef struct _TPrule_024* _TPPrule_024;
typedef struct _TPrule_025* _TPPrule_025;
typedef struct _TPrule_026* _TPPrule_026;
typedef struct _TPrule_027* _TPPrule_027;
typedef struct _TPrule_028* _TPPrule_028;
typedef struct _TPrule_029* _TPPrule_029;
typedef struct _TPrule_030* _TPPrule_030;
typedef struct _TPrule_031* _TPPrule_031;
typedef struct _TPrule_032* _TPPrule_032;
typedef struct _TPrule_033* _TPPrule_033;
typedef struct _TPrule_034* _TPPrule_034;
typedef struct _TPrule_035* _TPPrule_035;
typedef struct _TPrule_036* _TPPrule_036;
typedef struct _TPrule_037* _TPPrule_037;
typedef struct _TPrule_1* _TPPrule_1;
typedef struct _TPrule_2* _TPPrule_2;
typedef struct _TPrule_3* _TPPrule_3;
typedef struct _TPrule_4* _TPPrule_4;
typedef struct _TPrule_5* _TPPrule_5;
typedef struct _TPrule_6* _TPPrule_6;
typedef struct _TPrule_7* _TPPrule_7;
typedef struct _TPrule_8* _TPPrule_8;
typedef struct _TPrule_9* _TPPrule_9;
typedef struct _TPrule_10* _TPPrule_10;
typedef struct _TPrule_11* _TPPrule_11;
typedef struct _TPrule_12* _TPPrule_12;
typedef struct _TPrule_13* _TPPrule_13;
typedef struct _TPrule_14* _TPPrule_14;
typedef struct _TPrule_15* _TPPrule_15;
typedef struct _TPrule_16* _TPPrule_16;
typedef struct _TPrule_17* _TPPrule_17;
typedef struct _TPrule_18* _TPPrule_18;
typedef struct _TPrule_19* _TPPrule_19;
typedef struct _TPrule_20* _TPPrule_20;
typedef struct _TPrule_21* _TPPrule_21;
typedef struct _TPrule_22* _TPPrule_22;
typedef struct _TPrule_23* _TPPrule_23;
typedef struct _TPrule_24* _TPPrule_24;
typedef struct _TPrule_25* _TPPrule_25;
typedef struct _TPrule_26* _TPPrule_26;
typedef struct _TPrule_27* _TPPrule_27;
typedef struct _TPrule_28* _TPPrule_28;
typedef struct _TPrule_29* _TPPrule_29;
typedef struct _TPrule_30* _TPPrule_30;
typedef struct _TPrule_31* _TPPrule_31;
typedef struct _TPrule_32* _TPPrule_32;
typedef struct _TPrule_33* _TPPrule_33;
typedef struct _TPrule_34* _TPPrule_34;
typedef struct _TPrule_35* _TPPrule_35;
typedef struct _TPrule_36* _TPPrule_36;
typedef struct _TPrule_37* _TPPrule_37;
typedef struct _TPrule_38* _TPPrule_38;
typedef struct _TPrule_39* _TPPrule_39;
typedef struct _TPrule_40* _TPPrule_40;
typedef struct _TPrule_41* _TPPrule_41;
typedef struct _TPrule_42* _TPPrule_42;
typedef struct _TPrule_43* _TPPrule_43;
typedef struct _TPrule_44* _TPPrule_44;
typedef struct _TPrule_45* _TPPrule_45;
typedef struct _TPrule_46* _TPPrule_46;
typedef struct _TPrule_47* _TPPrule_47;
typedef struct _TPrule_48* _TPPrule_48;
typedef struct _TPrule_49* _TPPrule_49;
typedef struct _TPrule_50* _TPPrule_50;
typedef struct _TPrule_51* _TPPrule_51;
typedef struct _TPrule_52* _TPPrule_52;
typedef struct _TPrule_53* _TPPrule_53;
typedef struct _TPrule_54* _TPPrule_54;
typedef struct _TPrule_55* _TPPrule_55;
typedef struct _TPrule_56* _TPPrule_56;
typedef struct _TPrule_57* _TPPrule_57;
typedef struct _TPrule_58* _TPPrule_58;
typedef struct _TPrule_59* _TPPrule_59;
typedef struct _TPrule_60* _TPPrule_60;
typedef struct _TPrule_61* _TPPrule_61;
typedef struct _TPrule_62* _TPPrule_62;
typedef struct _TPrule_63* _TPPrule_63;
typedef struct _TPrule_64* _TPPrule_64;
typedef struct _TPrule_65* _TPPrule_65;
typedef struct _TPrule_66* _TPPrule_66;
typedef struct _TPrule_67* _TPPrule_67;
typedef struct _TPrule_68* _TPPrule_68;
typedef struct _TPrule_69* _TPPrule_69;
typedef struct _TPrule_70* _TPPrule_70;
typedef struct _TPrule_71* _TPPrule_71;
typedef struct _TPrule_72* _TPPrule_72;
typedef struct _TPrule_73* _TPPrule_73;
typedef struct _TPrule_74* _TPPrule_74;
typedef struct _TPrule_75* _TPPrule_75;
typedef struct _TPrule_76* _TPPrule_76;
typedef struct _TPrule_77* _TPPrule_77;
typedef struct _TPrule_78* _TPPrule_78;
typedef struct _TPrule_79* _TPPrule_79;
typedef struct _TPrule_80* _TPPrule_80;
typedef struct _TPrule_81* _TPPrule_81;
typedef struct _TPrule_82* _TPPrule_82;
typedef struct _TPrule_83* _TPPrule_83;
typedef struct _TPrule_84* _TPPrule_84;
typedef struct _TPrule_85* _TPPrule_85;
typedef struct _TPrule_86* _TPPrule_86;
typedef struct _TPrule_87* _TPPrule_87;
typedef struct _TPrule_88* _TPPrule_88;
typedef struct _TPrule_89* _TPPrule_89;

struct _TSAG
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
Environment _ATInitAttrEnv;
Environment _ATAttrEnv;
Environment _ATInitEnv;
Environment _ATNamedEnv;
};

struct _TSSpecs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSSymSpec
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATTermType;
int _ATSymClass;
int _ATTreeOrClass;
int _ATHasComps;
};

struct _TSSymClass
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATSymClass;
};

struct _TSSymSpecIds
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSAttrDefsOpt
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
TList _ATSymKeys;
};

struct _TSSymSpecId
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATKey;
};

struct _TSSymComp
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATTermType;
DefTableKey _ATKey;
DefTableKey _ATLhsSymKey;
bool _ATIsSymComp;
int _ATSymClass;
int _ATTreeOrClass;
TList _ATProduction;
int _ATHasComps;
};

struct _TSInheritOpt
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSCompPart
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSAttrDef
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATTypeDid;
int _ATClass;
};

struct _TSAttrDefIds
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSTypeId
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATSym;
DefTableKey _ATKey;
};

struct _TSClass
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSAttrDefId
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSAttr
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATAttrSymKey;
DefTableKey _ATKey;
bool _ATIsChain;
};

struct _TSSymOcc
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATIsCIdent;
DefTableKey _ATKey;
int _ATSym;
int _ATProdPos;
bool _ATMayDenoteTerm;
};

struct _TSDefAttr
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATAttrSymKey;
DefTableKey _ATKey;
bool _ATIsChain;
};

struct _TSLocAttr
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
Expr _ATExpr;
};

struct _TSRemoteAttr
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSSymId
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATSym;
DefTableKey _ATKey;
bool _ATMayDenoteTerm;
};

struct _TSIndex
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATval;
};

struct _TSAttrComp
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATIsUpper;
};

struct _TSExpressionDep
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLoop
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSComputation
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATIsUpper;
DefTableKey _ATGenDefAttrKey;
bool _ATIsBottomUp;
};

struct _TSBottomUpOpt
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
bool _ATIsBottomUp;
};

struct _TSAttrSpec
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSAttrNames
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSChainSpec
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSAttrName
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSRuleSpecId
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATNamedKey;
DefTableKey _ATKey;
TList _ATProduction;
};

struct _TSRuleSpec
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATKey;
bool _ATIsSymComp;
TList _ATProduction;
DefTableKey _ATLhsSymKey;
};

struct _TSProduction
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
bool _ATDoMakeInh;
DefTableKey _ATLhsSymKey;
TList _ATProduction;
DefTableKey _ATListKey;
};

struct _TSExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSRhsAttrs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
Expr _ATExpr;
};

struct _TSParamsOpt
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSParams
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSParam
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSDepClause
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSDependence
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSDepAttr
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSDepAttrs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSRemoteExpression
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSRemoteClause
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSSubtree
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSShield
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSExpandOpt
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSShieldClause
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSShieldSym
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSInheritSym
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSSyntId
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATSymbCnt_post;
int _ATSymbCnt_pre;
int _ATTermCnt_post;
int _ATSym;
DefTableKey _ATKey;
bool _ATIsApplied;
};

struct _TSSyntUnits
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATSymbCnt_pre;
int _ATTermCnt_pre;
};

struct _TSSyntUnit
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATSymbCnt_pre;
};

struct _TSAlts
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSAlt
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATListKey;
DefTableKey _ATRuleKey;
bool _ATDoMakeInh;
};

struct _TSSpec
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSAttrDefs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSComputations
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSRemoteAttrs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSShieldSyms
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSInheritSyms
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_000
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPSpecs _desc1;
_TSPSpec _desc2;
};

struct _TPrule_001
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_002
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPSymSpec _desc1;
};

struct _TPrule_003
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPAttrSpec _desc1;
};

struct _TPrule_004
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPChainSpec _desc1;
};

struct _TPrule_005
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRuleSpec _desc1;
};

struct _TPrule_006
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPSymComp _desc1;
};

struct _TPrule_007
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPSymSpecId _desc1;
};

struct _TPrule_008
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPSymSpecIds _desc1;
_TSPSymSpecId _desc2;
};

struct _TPrule_009
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
TList _ATSymKeys;
_TSPAttrDefs _desc1;
};

struct _TPrule_010
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
TList _ATSymKeys;
};

struct _TPrule_011
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPAttrDef _desc1;
};

struct _TPrule_012
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPAttrDefs _desc1;
_TSPAttrDef _desc2;
};

struct _TPrule_013
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPAttrDefId _desc1;
};

struct _TPrule_014
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPAttrDefIds _desc1;
_TSPAttrDefId _desc2;
};

struct _TPrule_015
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATSym;
DefTableKey _ATKey;
POSITION _AT_pos;
};

struct _TPrule_016
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPAttrNames _desc1;
_TSPAttrName _desc2;
};

struct _TPrule_017
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPAttrName _desc1;
};

struct _TPrule_018
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPAlts _desc1;
_TSPAlt _desc2;
};

struct _TPrule_019
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPAlt _desc1;
};

struct _TPrule_020
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPComputations _desc1;
};

struct _TPrule_021
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_022
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPComputation _desc1;
_TSPComputations _desc2;
};

struct _TPrule_023
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_024
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRemoteAttr _desc1;
};

struct _TPrule_025
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRemoteAttrs _desc1;
};

struct _TPrule_026
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRemoteAttr _desc1;
};

struct _TPrule_027
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRemoteAttr _desc1;
_TSPRemoteAttrs _desc2;
};

struct _TPrule_028
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPShieldSym _desc1;
};

struct _TPrule_029
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPShieldSyms _desc1;
};

struct _TPrule_030
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_031
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPShieldSyms _desc1;
_TSPShieldSym _desc2;
};

struct _TPrule_032
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPShieldSym _desc1;
};

struct _TPrule_033
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATSym;
DefTableKey _ATKey;
bool _ATMayDenoteTerm;
POSITION _AT_pos;
};

struct _TPrule_034
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPInheritSyms _desc1;
};

struct _TPrule_035
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_036
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPInheritSyms _desc1;
_TSPInheritSym _desc2;
};

struct _TPrule_037
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPInheritSym _desc1;
};

struct _TPrule_1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
Environment _ATInitAttrEnv;
Environment _ATAttrEnv;
Environment _ATInitEnv;
Environment _ATNamedEnv;
_TSPSpecs _desc1;
POSITION _AT_pos;
};

struct _TPrule_2
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATTermType;
int _ATSymClass;
int _ATTreeOrClass;
int _ATHasComps;
_TSPSymClass _desc1;
_TSPSymSpecIds _desc2;
_TSPAttrDefsOpt _desc3;
};

struct _TPrule_3
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATKey;
POSITION _AT_pos;
int _ATTERM_1;
};

struct _TPrule_4
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATTermType;
DefTableKey _ATKey;
DefTableKey _ATLhsSymKey;
bool _ATIsSymComp;
int _ATSymClass;
int _ATTreeOrClass;
TList _ATProduction;
int _ATHasComps;
_TSPSymClass _desc1;
_TSPSymSpecId _desc2;
_TSPInheritOpt _desc3;
_TSPCompPart _desc4;
};

struct _TPrule_5
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATTypeDid;
int _ATClass;
_TSPAttrDefIds _desc1;
_TSPTypeId _desc2;
_TSPClass _desc3;
};

struct _TPrule_6
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
POSITION _AT_pos;
int _ATTERM_1;
};

struct _TPrule_7
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATAttrSymKey;
DefTableKey _ATKey;
bool _ATIsChain;
_TSPSymOcc _desc1;
POSITION _AT_pos;
int _ATTERM_1;
};

struct _TPrule_8
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATAttrSymKey;
DefTableKey _ATKey;
bool _ATIsChain;
_TSPSymOcc _desc1;
POSITION _AT_pos;
int _ATTERM_1;
};

struct _TPrule_9
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
Expr _ATExpr;
POSITION _AT_pos;
int _ATTERM_1;
};

struct _TPrule_10
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATAttrSymKey;
DefTableKey _ATKey;
bool _ATIsChain;
POSITION _AT_pos;
int _ATTERM_1;
};

struct _TPrule_11
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPSymId _desc1;
POSITION _AT_pos;
int _ATTERM_1;
};

struct _TPrule_12
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATIsCIdent;
DefTableKey _ATKey;
int _ATSym;
int _ATProdPos;
bool _ATMayDenoteTerm;
_TSPSymId _desc1;
_TSPIndex _desc2;
POSITION _AT_pos;
};

struct _TPrule_13
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATIsUpper;
_TSPDefAttr _desc1;
_TSPExpressionDep _desc2;
int _AT_col;
int _AT_line;
};

struct _TPrule_14
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATIsUpper;
_TSPDefAttr _desc1;
_TSPLoop _desc2;
POSITION _AT_pos;
};

struct _TPrule_15
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPExpressionDep _desc1;
_TSPDefAttr _desc2;
_TSPExpressionDep _desc3;
POSITION _AT_pos;
};

struct _TPrule_16
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATIsUpper;
DefTableKey _ATGenDefAttrKey;
bool _ATIsBottomUp;
_TSPAttrComp _desc1;
_TSPBottomUpOpt _desc2;
int _AT_col;
int _AT_line;
POSITION _AT_pos;
};

struct _TPrule_17
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPAttrNames _desc1;
_TSPTypeId _desc2;
_TSPClass _desc3;
};

struct _TPrule_18
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPAttrNames _desc1;
_TSPTypeId _desc2;
};

struct _TPrule_19
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
POSITION _AT_pos;
int _ATTERM_1;
};

struct _TPrule_20
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
POSITION _AT_pos;
int _ATTERM_1;
};

struct _TPrule_21
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_22
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATNamedKey;
DefTableKey _ATKey;
TList _ATProduction;
POSITION _AT_pos;
int _ATTERM_1;
};

struct _TPrule_23
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATKey;
bool _ATIsSymComp;
TList _ATProduction;
DefTableKey _ATLhsSymKey;
_TSPRuleSpecId _desc1;
_TSPProduction _desc2;
_TSPCompPart _desc3;
};

struct _TPrule_24
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATIsUpper;
DefTableKey _ATGenDefAttrKey;
bool _ATIsBottomUp;
_TSPAttrComp _desc1;
_TSPBottomUpOpt _desc2;
};

struct _TPrule_25
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
bool _ATIsBottomUp;
};

struct _TPrule_26
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
bool _ATIsBottomUp;
};

struct _TPrule_27
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATIsUpper;
DefTableKey _ATGenDefAttrKey;
bool _ATIsBottomUp;
_TSPExpressionDep _desc1;
_TSPBottomUpOpt _desc2;
POSITION _AT_pos;
int _ATauxId_RuleAttr_235;
};

struct _TPrule_28
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATIsUpper;
DefTableKey _ATGenDefAttrKey;
bool _ATIsBottomUp;
_TSPLoop _desc1;
_TSPBottomUpOpt _desc2;
POSITION _AT_pos;
};

struct _TPrule_29
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPAttr _desc1;
};

struct _TPrule_30
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLocAttr _desc1;
};

struct _TPrule_31
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _AT_col;
int _AT_line;
int _ATTERM_1;
};

struct _TPrule_32
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
POSITION _AT_pos;
int _ATTERM_1;
};

struct _TPrule_33
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _AT_col;
int _AT_line;
int _ATTERM_1;
};

struct _TPrule_34
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
POSITION _AT_pos;
int _ATTERM_1;
};

struct _TPrule_35
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRhsAttrs _desc1;
};

struct _TPrule_36
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
Expr _ATExpr;
int _AT_col;
int _AT_line;
int _ATTERM_1;
};

struct _TPrule_37
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParamsOpt _desc1;
int _AT_col;
int _AT_line;
int _ATTERM_1;
};

struct _TPrule_38
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParams _desc1;
};

struct _TPrule_39
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParam _desc1;
};

struct _TPrule_40
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPParam _desc1;
_TSPParams _desc2;
};

struct _TPrule_41
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPExpressionDep _desc1;
};

struct _TPrule_42
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPExpression _desc1;
};

struct _TPrule_43
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPSymOcc _desc1;
int _AT_col;
int _AT_line;
POSITION _AT_pos;
};

struct _TPrule_44
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_45
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPExpression _desc1;
_TSPDepClause _desc2;
int _AT_col;
int _AT_line;
};

struct _TPrule_46
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPDependence _desc1;
};

struct _TPrule_47
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPDependence _desc1;
};

struct _TPrule_48
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPDepAttr _desc1;
};

struct _TPrule_49
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPDepAttrs _desc1;
};

struct _TPrule_50
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPDepAttr _desc1;
_TSPDepAttrs _desc2;
};

struct _TPrule_51
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPDepAttr _desc1;
};

struct _TPrule_52
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRemoteExpression _desc1;
};

struct _TPrule_53
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPAttr _desc1;
};

struct _TPrule_54
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLocAttr _desc1;
};

struct _TPrule_55
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRhsAttrs _desc1;
};

struct _TPrule_56
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRemoteExpression _desc1;
};

struct _TPrule_57
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPRemoteClause _desc1;
POSITION _AT_pos;
};

struct _TPrule_58
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPSubtree _desc1;
_TSPRemoteClause _desc2;
_TSPShield _desc3;
_TSPExpandOpt _desc4;
int _AT_col;
int _AT_line;
};

struct _TPrule_59
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPSubtree _desc1;
_TSPRemoteClause _desc2;
_TSPShield _desc3;
int _AT_col;
int _AT_line;
};

struct _TPrule_60
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTypeId _desc1;
int _AT_col;
int _AT_line;
int _ATTERM_1;
int _ATTERM_2;
int _ATTERM_3;
};

struct _TPrule_61
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_62
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPSymOcc _desc1;
};

struct _TPrule_63
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_64
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPShieldClause _desc1;
int _AT_col;
int _AT_line;
};

struct _TPrule_65
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_66
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPSymId _desc1;
POSITION _AT_pos;
};

struct _TPrule_67
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPSymId _desc1;
POSITION _AT_pos;
};

struct _TPrule_68
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATSymbCnt_post;
int _ATSymbCnt_pre;
int _ATTermCnt_post;
int _ATSym;
DefTableKey _ATKey;
bool _ATIsApplied;
POSITION _AT_pos;
};

struct _TPrule_69
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATSymClass;
};

struct _TPrule_70
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATSymClass;
};

struct _TPrule_71
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATSymClass;
};

struct _TPrule_72
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATSymClass;
};

struct _TPrule_73
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATSymClass;
};

struct _TPrule_74
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATSymClass;
};

struct _TPrule_75
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATSymClass;
};

struct _TPrule_76
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATNamedKey;
DefTableKey _ATKey;
TList _ATProduction;
POSITION _AT_pos;
};

struct _TPrule_77
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
bool _ATDoMakeInh;
DefTableKey _ATLhsSymKey;
TList _ATProduction;
DefTableKey _ATListKey;
_TSPSyntId _desc1;
_TSPSyntUnits _desc2;
POSITION _AT_pos;
};

struct _TPrule_78
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATSymbCnt_pre;
int _ATTermCnt_pre;
_TSPSyntUnit _desc1;
_TSPSyntUnits _desc2;
};

struct _TPrule_79
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATSymbCnt_pre;
int _ATTermCnt_pre;
};

struct _TPrule_80
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATSymbCnt_pre;
_TSPSyntId _desc1;
POSITION _AT_pos;
};

struct _TPrule_81
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATSymbCnt_pre;
POSITION _AT_pos;
int _ATTERM_1;
};

struct _TPrule_82
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATval;
POSITION _AT_pos;
int _ATTERM_1;
};

struct _TPrule_83
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATval;
};

struct _TPrule_84
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
bool _ATDoMakeInh;
DefTableKey _ATLhsSymKey;
TList _ATProduction;
DefTableKey _ATListKey;
_TSPSyntId _desc1;
_TSPAlts _desc2;
POSITION _AT_pos;
};

struct _TPrule_85
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATListKey;
DefTableKey _ATRuleKey;
bool _ATDoMakeInh;
};

struct _TPrule_86
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATListKey;
DefTableKey _ATRuleKey;
bool _ATDoMakeInh;
_TSPSyntId _desc1;
POSITION _AT_pos;
};

struct _TPrule_87
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATSymbCnt_pre;
int _ATTermCnt_pre;
_TSPSyntId _desc1;
_TSPSyntUnits _desc2;
POSITION _AT_pos;
};

struct _TPrule_88
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATTermType;
int _ATSymClass;
int _ATTreeOrClass;
int _ATHasComps;
_TSPSymClass _desc1;
_TSPSymSpecIds _desc2;
_TSPTypeId _desc3;
POSITION _AT_pos;
};

struct _TPrule_89
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPIndex _desc1;
POSITION _AT_pos;
};

#undef _NODECOMMON
#endif
