
/* interface of tree construction functions */

#ifndef TREECON_H
#define TREECON_H
#include "eliproto.h"

#include "err.h"

#include "nodeptr.h"

#include "HEAD.h"


extern void InitTree ELI_ARG((void));

extern void FreeTree ELI_ARG((void));

extern NODEPTR MkSyntId ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkProductionLit ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkSymSpecId ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkSymId ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkRuleName ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkTypeId ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkAttrName ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkAttrDefId ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkSyntUnits ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkRuleSpec ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkRuleSpecId ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkProduction ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkComputation ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkAlts ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkSyntUnit ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkAlt ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkAG ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkSpec ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkSymSpec ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkAttrSpec ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkChainSpec ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkSymComp ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkSymClass ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkSymSpecIds ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkAttrDef ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkAttrDefIds ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkClass ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkAttrNames ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkAttrComp ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkBottomUpOpt ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkExpressionDep ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkLoop ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkDefAttr ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkSymOcc ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkIndex ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkExpression ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkDepClause ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkAttr ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkLocAttr ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkParamsOpt ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkRemoteExpression ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkRhsAttrs ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkDepAttr ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkParams ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkParam ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkRemoteAttr ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkSubtree ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkShield ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkExpandOpt ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkShieldSym ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkInheritSym ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR Mkrule_000 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_001 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_002 ELI_ARG((POSITION *_coordref));
extern NODEPTR Mkrule_003 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_004 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_005 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_006 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_007 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_008 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3));
extern NODEPTR Mkrule_009 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3));
extern NODEPTR Mkrule_010 ELI_ARG((POSITION *_coordref));
extern NODEPTR Mkrule_011 ELI_ARG((POSITION *_coordref));
extern NODEPTR Mkrule_012 ELI_ARG((POSITION *_coordref));
extern NODEPTR Mkrule_013 ELI_ARG((POSITION *_coordref));
extern NODEPTR Mkrule_014 ELI_ARG((POSITION *_coordref));
extern NODEPTR Mkrule_015 ELI_ARG((POSITION *_coordref));
extern NODEPTR Mkrule_016 ELI_ARG((POSITION *_coordref));
extern NODEPTR Mkrule_017 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_018 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_019 ELI_ARG((POSITION *_coordref));
extern NODEPTR Mkrule_020 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_021 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3));
extern NODEPTR Mkrule_022 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_023 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_024 ELI_ARG((POSITION *_coordref, int _TERM1));
extern NODEPTR Mkrule_025 ELI_ARG((POSITION *_coordref));
extern NODEPTR Mkrule_026 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3));
extern NODEPTR Mkrule_027 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_028 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_029 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_030 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_031 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_032 ELI_ARG((POSITION *_coordref));
extern NODEPTR Mkrule_033 ELI_ARG((POSITION *_coordref));
extern NODEPTR Mkrule_034 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_035 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_036 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_037 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_038 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_039 ELI_ARG((POSITION *_coordref));
extern NODEPTR Mkrule_040 ELI_ARG((POSITION *_coordref));
extern NODEPTR Mkrule_041 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_042 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_043 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, int _TERM1));
extern NODEPTR Mkrule_044 ELI_ARG((POSITION *_coordref, int _TERM1));
extern NODEPTR Mkrule_045 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_046 ELI_ARG((POSITION *_coordref, int _TERM1));
extern NODEPTR Mkrule_047 ELI_ARG((POSITION *_coordref));
extern NODEPTR Mkrule_048 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_049 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_050 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_051 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_052 ELI_ARG((POSITION *_coordref, int _TERM1, NODEPTR _desc1));
extern NODEPTR Mkrule_053 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_054 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_055 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_056 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_057 ELI_ARG((POSITION *_coordref, int _TERM1));
extern NODEPTR Mkrule_058 ELI_ARG((POSITION *_coordref, int _TERM1));
extern NODEPTR Mkrule_059 ELI_ARG((POSITION *_coordref, int _TERM1));
extern NODEPTR Mkrule_060 ELI_ARG((POSITION *_coordref, int _TERM1));
extern NODEPTR Mkrule_061 ELI_ARG((POSITION *_coordref, int _TERM1));
extern NODEPTR Mkrule_062 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, int _TERM1));
extern NODEPTR Mkrule_063 ELI_ARG((POSITION *_coordref, int _TERM1));
extern NODEPTR Mkrule_064 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_065 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_066 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_067 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_068 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_069 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_070 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_071 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_072 ELI_ARG((POSITION *_coordref));
extern NODEPTR Mkrule_073 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_074 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_075 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_076 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3));
extern NODEPTR Mkrule_077 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_078 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4));
extern NODEPTR Mkrule_079 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3));
extern NODEPTR Mkrule_080 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_081 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, int _TERM1));
extern NODEPTR Mkrule_082 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, int _TERM1, int _TERM2, int _TERM3));
extern NODEPTR Mkrule_083 ELI_ARG((POSITION *_coordref));
extern NODEPTR Mkrule_084 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_085 ELI_ARG((POSITION *_coordref));
extern NODEPTR Mkrule_086 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_087 ELI_ARG((POSITION *_coordref));
extern NODEPTR Mkrule_088 ELI_ARG((POSITION *_coordref));
extern NODEPTR Mkrule_089 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_090 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_091 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4));
extern NODEPTR Mkrule_092 ELI_ARG((POSITION *_coordref));
extern NODEPTR Mkrule_093 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_094 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_1 ELI_ARG((POSITION *_coordref, int _TERM1));
extern NODEPTR Mkrule_2 ELI_ARG((POSITION *_coordref, int _TERM1));
extern NODEPTR Mkrule_3 ELI_ARG((POSITION *_coordref, int _TERM1));
extern NODEPTR Mkrule_4 ELI_ARG((POSITION *_coordref, int _TERM1));
extern NODEPTR Mkrule_5 ELI_ARG((POSITION *_coordref, int _TERM1));
extern NODEPTR Mkrule_6 ELI_ARG((POSITION *_coordref, int _TERM1));
extern NODEPTR Mkrule_7 ELI_ARG((POSITION *_coordref, int _TERM1));
extern NODEPTR Mkrule_8 ELI_ARG((POSITION *_coordref, int _TERM1));
extern NODEPTR Mkrule_9 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_10 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3));
extern NODEPTR Mkrule_11 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_12 ELI_ARG((POSITION *_coordref));
extern NODEPTR Mkrule_13 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_14 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_15 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_16 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_17 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_18 ELI_ARG((POSITION *_coordref));
extern NODEPTR Mkrule_19 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
#define MkC_Float(pos,val) (val)
#define MkC_String(pos,val) (val)
#define MkP_String(pos,val) (val)
#define MkC_Integer(pos,val) (val)
#define MkIdentifier(pos,val) (val)
#endif
