#ifndef HEAD_H1
#define HEAD_H1
/* $Id: liga.head,v 4.3 1997/09/15 14:46:48 cogito Exp $ */
/* (C) Copyright 1997 University of Paderborn */

/* This file is part of the Eli Module Library.

The Eli Module Library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public License as
published by the Free Software Foundation; either version 2 of the
License, or (at your option) any later version.

The Eli Module Library is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with the Eli Module Library; see the file COPYING.LIB.
If not, write to the Free Software Foundation, Inc., 59 Temple Place -
Suite 330, Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Eli into the
   directory resulting from a :source derivation, you may use that
   created file as a part of that directory without restriction. */

#include "treecon.h"

#endif

#ifndef HEAD_H2
#define HEAD_H2
/*
 * clp.head,v 1.7 1997/09/08 04:56:26 kadhim Exp
 * Header file for CLP
 */

#include "clp.h"
#endif

#ifndef HEAD_H3
#define HEAD_H3
/* $Id: option.head,v 1.3 2001/11/05 17:23:46 cogito Exp $ */
/* $Log: option.head,v $
 * Revision 1.3  2001/11/05 17:23:46  cogito
 * *** empty log message ***
 *
 * Revision 1.1  1996/02/06 13:30:25  cogito
 * Initial revision
 *
Revision 2.8  1993/04/05  07:49:39  peter
n

Revision 2.7  1992/11/13  12:58:44  cogito
option reader now uses clp to access command line parameters

Revision 2.6  1991/11/08  14:52:39  cogito
include #include "err.h:

Revision 2.5  1991/11/08  12:14:12  cogito
*** empty log message ***

Revision 2.4  1991/09/12  12:18:49  mjung
'typedef int SYMB' removed. (Conflicts in Eli3.0)

Revision 2.3  1991/07/23  17:20:46  cogito
expand options: INCLUDING_FUNCTION replaced by INCLUDING ON / OFF
order options: new option ARRANGE FAST to cancel default ARRANGE AUTOMATICALLY
backend options: new option FREE_TREE (opposite of KEEP_TREE)

Revision 2.2  91/05/15  08:32:46  cogito
removed unused expand options

Revision 2.1  90/12/04  14:21:59  cogito
new version of option handler
 */

/***********************************************************************\
*	option.head							*
*	Header file for specification of the LIDO option handler	*
*									*
*	Written 11/13/90 - 07/23/91	by HaDeS			*
\***********************************************************************/

#ifndef _OPTION_HEAD_INCL
#define _OPTION_HEAD_INCL


#include <string.h>
#include "csm.h"
#include "option_enums.h"
#include "option_types.h"
#include "keywords.h"
#include "various.h"
#include "optlists.h"
#include "output.h"
#include "conflicts.h"
#include "err.h"

extern	char *exp_fname, *ord_fname, *opt_fname, *be_fname;


extern	ExpOption	ExpOptEnter1();
extern	ExpOption	ExpOptEnter2();
extern	ExpOption	ExpOptEnter3();

extern	OrdOption	OrdOptEnter1();
extern	OrdOption	OrdOptEnter2();
extern	OrdOption	OrdOptEnter3();
extern	OrdOption	OrdOptEnter4();
extern	OrdOption	OrdOptEnter5();
extern	OrdOption	OrdOptEnter6();
extern	OrdOption	OrdOptEnter7();

extern	OptOption	OptOptEnter1();
extern	OptOption	OptOptEnter2();
extern	OptOption	OptOptEnter3();

extern	BEOption	BEOptEnter1();
extern	BEOption	BEOptEnter2();

extern	OptCollect	InitOpts();
extern	OptCollect	JoinOpts();
extern	int		Mix_Options();

extern	OptCombin	TransferOpts1();
extern	OptCombin	TransferOpts2();
extern	OptCombin	TransferOpts3();
extern	OptCombin	TransferOpts4();

#endif

#endif

#ifndef HEAD_H4
#define HEAD_H4
#include "pdl_gen.h"
#endif

#ifndef HEAD_H5
#define HEAD_H5

#include "DefTableKeyList.h"
#endif

#ifndef HEAD_H6
#define HEAD_H6
/* deftbl.head,v 1.1 1992/06/20 19:04:11 kadhim Exp */
/* Type definitions for the property list module */

#include "deftbl.h"

#endif

#ifndef HEAD_H7
#define HEAD_H7

#include "VoidPtrList.h"
#endif

