#define NONLITCOUNT 4
#define LITCOUNT 25
#define NTOKENS 29
#define EOFTOKEN 1
#if defined(__cplusplus) || defined(__STDC__)
extern void mkidn(char *, int, int *, int *),
 mkint(char *, int, int *, int *),
 dummy1(char *, int, int *, int *);
#else
extern void mkidn(),
 mkint(),
 dummy1();
#endif
#if defined(__cplusplus) || defined(__STDC__)
extern char *auxCComment(char *, int),
 *auxEOL(char *, int),
 *dummy2(char *, int);
#else
extern char *auxCComment(),
 *auxEOL(),
 *dummy2();
#endif
#ifdef MONITOR
int mon_nonlit_codes[] = {
 8,
 23,
 15001,
 15001,
 -1
};
char *mon_token_names[] = {
 "Identifier",
 "IntNumber",
 "",
 "",
 ""
};
#endif

static short CaseTbl[128] = {
  0,  0,  0,  0,  0,  0,  0,  0,     /*   0.  1.  2.  3.  4.  5.  6.  7. */
  0,  2,  3,  0,  0,  0,  0,  0,     /*   8.  9. 10. 11. 12. 13. 14. 15. */
  0,  0,  0,  0,  0,  0,  0,  0,     /*  16. 17. 18. 19. 20. 21. 22. 23. */
  0,  0,  0,  0,  0,  0,  0,  0,     /*  24. 25. 26. 27. 28. 29. 30. 31. */
  1,  0,  0, 17,  0,  0,  0,  0,     /*  32. ! " # $ % & ' */
  0,  0,  0,  0, 18,  0, 18, 16,     /*  ( ) * + , - . / */
  5,  5,  5,  5,  5,  5,  5,  5,     /*  0 1 2 3 4 5 6 7 */
  5,  5, 18, 18,  0,  0,  0,  0,     /*  8 9 : ; < = > ? */
  0, 15, 14,  4,  4, 13, 12, 11,     /*  @ A B C D E F G */
  4, 10,  4,  4,  4,  4,  4,  9,     /*  H I J K L M N O */
  4,  4,  8,  7,  6,  4,  4,  4,     /*  P Q R S T U V W */
  4,  4,  4, 18,  0, 18,  0,  4,     /*  X Y Z [ \ ] ^ _ */
  0,  4,  4,  4,  4,  4,  4,  4,     /*  ` a b c d e f g */
  4,  4,  4,  4,  4,  4,  4,  4,     /*  h i j k l m n o */
  4,  4,  4,  4,  4,  4,  4,  4,     /*  p q r s t u v w */
  4,  4,  4,  0,  0,  0,  0,  0};    /*  x y z { | } ~ 127. */

static short ExtCodeTbl[128] = {
  0,  0,  0,  0,  0,  0,  0,  0,     /*   0.  1.  2.  3.  4.  5.  6.  7. */
  0,  0,  0,  0,  0,  0,  0,  0,     /*   8.  9. 10. 11. 12. 13. 14. 15. */
  0,  0,  0,  0,  0,  0,  0,  0,     /*  16. 17. 18. 19. 20. 21. 22. 23. */
  0,  0,  0,  0,  0,  0,  0,  0,     /*  24. 25. 26. 27. 28. 29. 30. 31. */
  0,  0,  0,  0,  0,  0,  0,  0,     /*  32. ! " # $ % & ' */
  0,  0,  0,  0,  9,  0, 25,  0,     /*  ( ) * + , - . / */
  0,  0,  0,  0,  0,  0,  0,  0,     /*  0 1 2 3 4 5 6 7 */
  0,  0,  4,  2,  0,  0,  0,  0,     /*  8 9 : ; < = > ? */
  0,  0,  0,  0,  0,  0,  0,  0,     /*  @ A B C D E F G */
  0,  0,  0,  0,  0,  0,  0,  0,     /*  H I J K L M N O */
  0,  0,  0,  0,  0,  0,  0,  0,     /*  P Q R S T U V W */
  0,  0,  0, 22,  0, 24,  0,  0,     /*  X Y Z [ \ ] ^ _ */
  0,  0,  0,  0,  0,  0,  0,  0,     /*  ` a b c d e f g */
  0,  0,  0,  0,  0,  0,  0,  0,     /*  h i j k l m n o */
  0,  0,  0,  0,  0,  0,  0,  0,     /*  p q r s t u v w */
  0,  0,  0,  0,  0,  0,  0,  0};    /*  x y z { | } ~ 127. */
static unsigned char ScanTbl[] = {
0x00, 0x00, 0x00, 0x00,	/*   0.   1.   2.   3. */
0x00, 0x00, 0x00, 0x00,	/*   4.   5.   6.   7. */
0x00, 0x02, 0x04, 0x00,	/*   8.   9.  10.  11. */
0x00, 0x00, 0x00, 0x00,	/*  12.  13.  14.  15. */
0x00, 0x00, 0x00, 0x00,	/*  16.  17.  18.  19. */
0x00, 0x00, 0x00, 0x00,	/*  20.  21.  22.  23. */
0x00, 0x00, 0x00, 0x00,	/*  24.  25.  26.  27. */
0x00, 0x00, 0x00, 0x00,	/*  28.  29.  30.  31. */
0x01, 0x00, 0x00, 0x00,	/*  32.  !  "  # */
0x00, 0x00, 0x00, 0x00,	/*  $  %  &  ' */
0x00, 0x00, 0x00, 0x00,	/*  (  )  *  + */
0x00, 0x00, 0x00, 0x00,	/*  ,  -  .  / */
0xF8, 0xF8, 0xF8, 0xF8,	/*  0  1  2  3 */
0xF8, 0xF8, 0xF8, 0xF8,	/*  4  5  6  7 */
0xF8, 0xF8, 0x00, 0x00,	/*  8  9  :  ; */
0x00, 0x00, 0x00, 0x00,	/*  <  =  >  ? */
0x00, 0xE8, 0xE8, 0xE8,	/*  @  A  B  C */
0xE8, 0xE8, 0xE8, 0xE8,	/*  D  E  F  G */
0xE8, 0xE8, 0xE8, 0xE8,	/*  H  I  J  K */
0xE8, 0xE8, 0xE8, 0xE8,	/*  L  M  N  O */
0xE8, 0xE8, 0xC8, 0xE8,	/*  P  Q  R  S */
0xE8, 0x68, 0xE8, 0xE8,	/*  T  U  V  W */
0xE8, 0xA8, 0xE8, 0x00,	/*  X  Y  Z  [ */
0x00, 0x00, 0x00, 0xE8,	/*  \  ]  ^  _ */
0x00, 0xE8, 0xE8, 0xE8,	/*  `  a  b  c */
0xE8, 0xE8, 0xE8, 0xE8,	/*  d  e  f  g */
0xE8, 0xE8, 0xE8, 0xE8,	/*  h  i  j  k */
0xE8, 0xE8, 0xE8, 0xE8,	/*  l  m  n  o */
0xE8, 0xE8, 0xE8, 0xE8,	/*  p  q  r  s */
0xE8, 0xE8, 0xE8, 0xE8,	/*  t  u  v  w */
0xE8, 0xE8, 0xE8, 0x00,	/*  x  y  z  { */
0x00, 0x00, 0x00, 0x00,	/*  |  }  ~  127. */
0x00, 0x00, 0x00, 0x00,	/*   0.   1.   2.   3. */
0x00, 0x00, 0x00, 0x00,	/*   4.   5.   6.   7. */
0x00, 0x00, 0x00, 0x00,	/*   8.   9.  10.  11. */
0x00, 0x00, 0x00, 0x00,	/*  12.  13.  14.  15. */
0x00, 0x00, 0x00, 0x00,	/*  16.  17.  18.  19. */
0x00, 0x00, 0x00, 0x00,	/*  20.  21.  22.  23. */
0x00, 0x00, 0x00, 0x00,	/*  24.  25.  26.  27. */
0x00, 0x00, 0x00, 0x00,	/*  28.  29.  30.  31. */
0x00, 0x00, 0x00, 0x00,	/*  32.  !  "  # */
0x00, 0x00, 0x00, 0x00,	/*  $  %  &  ' */
0x00, 0x00, 0x00, 0x00,	/*  (  )  *  + */
0x00, 0x00, 0x00, 0x00,	/*  ,  -  .  / */
0xFF, 0xFF, 0xFF, 0xFF,	/*  0  1  2  3 */
0xFF, 0xFF, 0xFF, 0xFF,	/*  4  5  6  7 */
0xFF, 0xFF, 0x00, 0x00,	/*  8  9  :  ; */
0x00, 0x00, 0x00, 0x00,	/*  <  =  >  ? */
0x00, 0xAB, 0xFF, 0xFF,	/*  @  A  B  C */
0xFF, 0xEF, 0xFF, 0x7F,	/*  D  E  F  G */
0xFF, 0xFF, 0xFF, 0xFF,	/*  H  I  J  K */
0xFF, 0xFF, 0xFD, 0xFB,	/*  L  M  N  O */
0xFE, 0xFF, 0xDE, 0xFF,	/*  P  Q  R  S */
0xDF, 0xDF, 0xF7, 0xFF,	/*  T  U  V  W */
0xF7, 0xFF, 0xFF, 0x00,	/*  X  Y  Z  [ */
0x00, 0x00, 0x00, 0xFF,	/*  \  ]  ^  _ */
0x00, 0xFF, 0xFF, 0xFF,	/*  `  a  b  c */
0xFF, 0xFF, 0xFF, 0xFF,	/*  d  e  f  g */
0xFF, 0xFF, 0xFF, 0xFF,	/*  h  i  j  k */
0xFF, 0xFF, 0xFF, 0xFF,	/*  l  m  n  o */
0xFF, 0xFF, 0xFF, 0xFF,	/*  p  q  r  s */
0xFF, 0xFF, 0xFF, 0xFF,	/*  t  u  v  w */
0xFF, 0xFF, 0xFF, 0x00,	/*  x  y  z  { */
0x00, 0x00, 0x00, 0x00,	/*  |  }  ~  127. */
0x00, 0x00, 0x00, 0x00,	/*   0.   1.   2.   3. */
0x00, 0x00, 0x00, 0x00,	/*   4.   5.   6.   7. */
0x00, 0x00, 0x00, 0x00,	/*   8.   9.  10.  11. */
0x00, 0x00, 0x00, 0x00,	/*  12.  13.  14.  15. */
0x00, 0x00, 0x00, 0x00,	/*  16.  17.  18.  19. */
0x00, 0x00, 0x00, 0x00,	/*  20.  21.  22.  23. */
0x00, 0x00, 0x00, 0x00,	/*  24.  25.  26.  27. */
0x00, 0x00, 0x00, 0x00,	/*  28.  29.  30.  31. */
0x00, 0x00, 0x00, 0x00,	/*  32.  !  "  # */
0x00, 0x00, 0x00, 0x00,	/*  $  %  &  ' */
0x00, 0x00, 0x00, 0x00,	/*  (  )  *  + */
0x00, 0x00, 0x00, 0x00,	/*  ,  -  .  / */
0xFF, 0xFF, 0xFF, 0xFF,	/*  0  1  2  3 */
0xFF, 0xFF, 0xFF, 0xFF,	/*  4  5  6  7 */
0xFF, 0xFF, 0x00, 0x00,	/*  8  9  :  ; */
0x00, 0x00, 0x00, 0x00,	/*  <  =  >  ? */
0x00, 0xFF, 0xFF, 0xFF,	/*  @  A  B  C */
0xFF, 0xFE, 0xFF, 0xFF,	/*  D  E  F  G */
0xFF, 0x7F, 0xFF, 0xFF,	/*  H  I  J  K */
0xFF, 0xBF, 0xFF, 0xDF,	/*  L  M  N  O */
0xF7, 0xFF, 0xFF, 0xFB,	/*  P  Q  R  S */
0xFD, 0xFF, 0xFF, 0xFF,	/*  T  U  V  W */
0xFF, 0xFF, 0xEF, 0x00,	/*  X  Y  Z  [ */
0x00, 0x00, 0x00, 0xFF,	/*  \  ]  ^  _ */
0x00, 0xFF, 0xFF, 0xFF,	/*  `  a  b  c */
0xFF, 0xFF, 0xFF, 0xFF,	/*  d  e  f  g */
0xFF, 0xFF, 0xFF, 0xFF,	/*  h  i  j  k */
0xFF, 0xFF, 0xFF, 0xFF,	/*  l  m  n  o */
0xFF, 0xFF, 0xFF, 0xFF,	/*  p  q  r  s */
0xFF, 0xFF, 0xFF, 0xFF,	/*  t  u  v  w */
0xFF, 0xFF, 0xFF, 0x00,	/*  x  y  z  { */
0x00, 0x00, 0x00, 0x00,	/*  |  }  ~  127. */
0x00, 0x00, 0x00, 0x00,	/*   0.   1.   2.   3. */
0x00, 0x00, 0x00, 0x00,	/*   4.   5.   6.   7. */
0x00, 0x00, 0x00, 0x00,	/*   8.   9.  10.  11. */
0x00, 0x00, 0x00, 0x00,	/*  12.  13.  14.  15. */
0x00, 0x00, 0x00, 0x00,	/*  16.  17.  18.  19. */
0x00, 0x00, 0x00, 0x00,	/*  20.  21.  22.  23. */
0x00, 0x00, 0x00, 0x00,	/*  24.  25.  26.  27. */
0x00, 0x00, 0x00, 0x00,	/*  28.  29.  30.  31. */
0x00, 0x00, 0x00, 0x00,	/*  32.  !  "  # */
0x00, 0x00, 0x00, 0x00,	/*  $  %  &  ' */
0x00, 0x00, 0x00, 0x00,	/*  (  )  *  + */
0x00, 0x00, 0x00, 0x00,	/*  ,  -  .  / */
0xFF, 0xFF, 0xFF, 0xFF,	/*  0  1  2  3 */
0xFF, 0xFF, 0xFF, 0xFF,	/*  4  5  6  7 */
0xFF, 0xFF, 0x00, 0x00,	/*  8  9  :  ; */
0x00, 0x00, 0x00, 0x00,	/*  <  =  >  ? */
0x00, 0xFF, 0xBF, 0xFE,	/*  @  A  B  C */
0xF7, 0xFF, 0xEF, 0xFF,	/*  D  E  F  G */
0xDF, 0xFF, 0xFF, 0xFB,	/*  H  I  J  K */
0xFD, 0xFF, 0xFF, 0xFF,	/*  L  M  N  O */
0xFF, 0xFF, 0xFF, 0xFF,	/*  P  Q  R  S */
0xFF, 0xFF, 0xFF, 0xFF,	/*  T  U  V  W */
0xFF, 0xFF, 0xFF, 0x00,	/*  X  Y  Z  [ */
0x00, 0x00, 0x00, 0x7F,	/*  \  ]  ^  _ */
0x00, 0xFF, 0xFF, 0xFF,	/*  `  a  b  c */
0xFF, 0xFF, 0xFF, 0xFF,	/*  d  e  f  g */
0xFF, 0xFF, 0xFF, 0xFF,	/*  h  i  j  k */
0xFF, 0xFF, 0xFF, 0xFF,	/*  l  m  n  o */
0xFF, 0xFF, 0xFF, 0xFF,	/*  p  q  r  s */
0xFF, 0xFF, 0xFF, 0xFF,	/*  t  u  v  w */
0xFF, 0xFF, 0xFF, 0x00,	/*  x  y  z  { */
0x00, 0x00, 0x00, 0x00,	/*  |  }  ~  127. */
0x00, 0x00, 0x00, 0x00,	/*   0.   1.   2.   3. */
0x00, 0x00, 0x00, 0x00,	/*   4.   5.   6.   7. */
0x00, 0x00, 0x00, 0x00,	/*   8.   9.  10.  11. */
0x00, 0x00, 0x00, 0x00,	/*  12.  13.  14.  15. */
0x00, 0x00, 0x00, 0x00,	/*  16.  17.  18.  19. */
0x00, 0x00, 0x00, 0x00,	/*  20.  21.  22.  23. */
0x00, 0x00, 0x00, 0x00,	/*  24.  25.  26.  27. */
0x00, 0x00, 0x00, 0x00,	/*  28.  29.  30.  31. */
0x00, 0x00, 0x00, 0x00,	/*  32.  !  "  # */
0x00, 0x00, 0x00, 0x00,	/*  $  %  &  ' */
0x00, 0x00, 0x00, 0x00,	/*  (  )  *  + */
0x00, 0x00, 0x00, 0x00,	/*  ,  -  .  / */
0x00, 0x00, 0x00, 0x00,	/*  0  1  2  3 */
0x00, 0x00, 0x00, 0x00,	/*  4  5  6  7 */
0x00, 0x00, 0x00, 0x00,	/*  8  9  :  ; */
0x00, 0x00, 0x00, 0x00,	/*  <  =  >  ? */
0x00, 0x00, 0x00, 0x00,	/*  @  A  B  C */
0x00, 0x00, 0x00, 0x00,	/*  D  E  F  G */
0x00, 0x00, 0x00, 0x00,	/*  H  I  J  K */
0x00, 0x00, 0x00, 0x00,	/*  L  M  N  O */
0x00, 0x00, 0x00, 0x00,	/*  P  Q  R  S */
0x00, 0x00, 0x00, 0x00,	/*  T  U  V  W */
0x00, 0x00, 0x00, 0x00,	/*  X  Y  Z  [ */
0x00, 0x00, 0x00, 0x00,	/*  \  ]  ^  _ */
0x00, 0x00, 0x00, 0x00,	/*  `  a  b  c */
0x00, 0x00, 0x00, 0x00,	/*  d  e  f  g */
0x00, 0x00, 0x00, 0x00,	/*  h  i  j  k */
0x00, 0x00, 0x00, 0x00,	/*  l  m  n  o */
0x00, 0x00, 0x00, 0x00,	/*  p  q  r  s */
0x00, 0x00, 0x00, 0x00,	/*  t  u  v  w */
0x00, 0x00, 0x00, 0x00,	/*  x  y  z  { */
0x00, 0x00, 0x00, 0x00 }; /*  |  }  ~  127. */
