
/* definition of tree node structure */

#ifndef NODE_H
#define NODE_H
#include "err.h"
#include "nodeptr.h" /* defines NODEPTR */
#include "HEAD.h"

#ifdef MONITOR
#define _NODECOMMON int _prod; POSITION _coord;
#else
#define _NODECOMMON int _prod;
#endif
struct NODEPTR_struct {
        _NODECOMMON
#ifdef __cplusplus
        void* operator new(size_t size);
#endif
};

typedef struct _TSCon* _TSPCon;
typedef struct _TSConProd* _TSPConProd;
typedef struct _TSConLHS* _TSPConLHS;
typedef struct _TSConAlt* _TSPConAlt;
typedef struct _TSConElement* _TSPConElement;
typedef struct _TSConIdent* _TSPConIdent;
typedef struct _TSConText* _TSPConText;
typedef struct _TSAbs* _TSPAbs;
typedef struct _TSAbsProd* _TSPAbsProd;
typedef struct _TSAbsSignature* _TSPAbsSignature;
typedef struct _TSAbsLHS* _TSPAbsLHS;
typedef struct _TSAbsElements* _TSPAbsElements;
typedef struct _TSAbsElement* _TSPAbsElement;
typedef struct _TSAbsAlts* _TSPAbsAlts;
typedef struct _TSAbsAlt* _TSPAbsAlt;
typedef struct _TSBottomUpRule* _TSPBottomUpRule;
typedef struct _TSMap* _TSPMap;
typedef struct _TSMapSymbol* _TSPMapSymbol;
typedef struct _TSMapRule* _TSPMapRule;
typedef struct _TSMapChains* _TSPMapChains;
typedef struct _TSMapMember* _TSPMapMember;
typedef struct _TSMapMembers* _TSPMapMembers;
typedef struct _TSMapProd* _TSPMapProd;
typedef struct _TSMapReorder* _TSPMapReorder;
typedef struct _TSMapLHS* _TSPMapLHS;
typedef struct _TSMapDelim* _TSPMapDelim;
typedef struct _TSMapAlt* _TSPMapAlt;
typedef struct _TSMapElement* _TSPMapElement;
typedef struct _TSMapReorderAlt* _TSPMapReorderAlt;
typedef struct _TSMapPosition* _TSPMapPosition;
typedef struct _TSMapText* _TSPMapText;
typedef struct _TSSource* _TSPSource;
typedef struct _TSBottomUpRules* _TSPBottomUpRules;
typedef struct _TSG15* _TSPG15;
typedef struct _TSLST_Con* _TSPLST_Con;
typedef struct _TSLST_ConAlt* _TSPLST_ConAlt;
typedef struct _TSLST_Abs* _TSPLST_Abs;
typedef struct _TSLST_AbsElements* _TSPLST_AbsElements;
typedef struct _TSLST_AbsAlts* _TSPLST_AbsAlts;
typedef struct _TSLST_Map* _TSPLST_Map;
typedef struct _TSLST_MapMembers* _TSPLST_MapMembers;
typedef struct _TSLST_MapAlt* _TSPLST_MapAlt;
typedef struct _TSLST_MapReorderAlt* _TSPLST_MapReorderAlt;
typedef struct _TPpConProd* _TPPpConProd;
typedef struct _TPpConLHS* _TPPpConLHS;
typedef struct _TPpConIdnElt* _TPPpConIdnElt;
typedef struct _TPpConTextElt* _TPPpConTextElt;
typedef struct _TPpConActionElt* _TPPpConActionElt;
typedef struct _TPpConAtModIdn* _TPPpConAtModIdn;
typedef struct _TPpConAtModTxt* _TPPpConAtModTxt;
typedef struct _TPpConDollarModIdn* _TPPpConDollarModIdn;
typedef struct _TPpConDollarModTxt* _TPPpConDollarModTxt;
typedef struct _TPpConIdent* _TPPpConIdent;
typedef struct _TPpConText* _TPPpConText;
typedef struct _TPpAbsProd* _TPPpAbsProd;
typedef struct _TPpAbsLHS* _TPPpAbsLHS;
typedef struct _TPpAbsEmptyRule* _TPPpAbsEmptyRule;
typedef struct _TPpAbsRule* _TPPpAbsRule;
typedef struct _TPpAbsEltIdn* _TPPpAbsEltIdn;
typedef struct _TPpAbsEltTxt* _TPPpAbsEltTxt;
typedef struct _TPpAbsEltGen* _TPPpAbsEltGen;
typedef struct _TPpAbsListof* _TPPpAbsListof;
typedef struct _TPpAbsAltIdn* _TPPpAbsAltIdn;
typedef struct _TPpMapSymbol* _TPPpMapSymbol;
typedef struct _TPpMapProdReorder* _TPPpMapProdReorder;
typedef struct _TPpMapProd* _TPPpMapProd;
typedef struct _TPpMapIdnElt* _TPPpMapIdnElt;
typedef struct _TPpMapTextElt* _TPPpMapTextElt;
typedef struct _TPpMapReorder* _TPPpMapReorder;
typedef struct _TPpMapPosition* _TPPpMapPosition;
typedef struct _TPpMapText* _TPPpMapText;
typedef struct _TPrule_000* _TPPrule_000;
typedef struct _TPrule_001* _TPPrule_001;
typedef struct _TPrule_002* _TPPrule_002;
typedef struct _TPrule_003* _TPPrule_003;
typedef struct _TPrule_004* _TPPrule_004;
typedef struct _TPrule_005* _TPPrule_005;
typedef struct _TPrule_006* _TPPrule_006;
typedef struct _TPrule_007* _TPPrule_007;
typedef struct _TPrule_008* _TPPrule_008;
typedef struct _TPrule_009* _TPPrule_009;
typedef struct _TPrule_010* _TPPrule_010;
typedef struct _TPrule_011* _TPPrule_011;
typedef struct _TPrule_012* _TPPrule_012;
typedef struct _TPrule_013* _TPPrule_013;
typedef struct _TPrule_014* _TPPrule_014;
typedef struct _TPrule_015* _TPPrule_015;
typedef struct _TPrule_016* _TPPrule_016;
typedef struct _TPrule_017* _TPPrule_017;
typedef struct _TPrule_018* _TPPrule_018;
typedef struct _TPrule_019* _TPPrule_019;
typedef struct _TPrule_020* _TPPrule_020;
typedef struct _TPrule_1* _TPPrule_1;
typedef struct _TPrule_2* _TPPrule_2;
typedef struct _TPrule_3* _TPPrule_3;
typedef struct _TPrule_4* _TPPrule_4;
typedef struct _TPrule_5* _TPPrule_5;
typedef struct _TPrule_6* _TPPrule_6;
typedef struct _TPrule_7* _TPPrule_7;
typedef struct _TPrule_8* _TPPrule_8;
typedef struct _TPrule_9* _TPPrule_9;
typedef struct _TPrule_10* _TPPrule_10;
typedef struct _TPrule_11* _TPPrule_11;
typedef struct _TPrule_12* _TPPrule_12;
typedef struct _TPrule_13* _TPPrule_13;
typedef struct _TPLST_ConProdrule_1* _TPPLST_ConProdrule_1;
typedef struct _TPLST_ConElementrule_2* _TPPLST_ConElementrule_2;
typedef struct _TPLST_AbsProdrule_3* _TPPLST_AbsProdrule_3;
typedef struct _TPLST_AbsElementrule_4* _TPPLST_AbsElementrule_4;
typedef struct _TPLST_AbsAltrule_5* _TPPLST_AbsAltrule_5;
typedef struct _TPLST_MapSymbolrule_7* _TPPLST_MapSymbolrule_7;
typedef struct _TPLST_MapRulerule_7* _TPPLST_MapRulerule_7;
typedef struct _TPLST_MapChainsrule_7* _TPPLST_MapChainsrule_7;
typedef struct _TPLST_MapMemberrule_9* _TPPLST_MapMemberrule_9;
typedef struct _TPLST_MapElementrule_11* _TPPLST_MapElementrule_11;
typedef struct _TPLST_MapPositionrule_12* _TPPLST_MapPositionrule_12;
typedef struct _TPLST_MapTextrule_12* _TPPLST_MapTextrule_12;
typedef struct _TPLST_0rule_1* _TPPLST_0rule_1;
typedef struct _TPLST_0rule_2* _TPPLST_0rule_2;
typedef struct _TPLST_0rule_3* _TPPLST_0rule_3;
typedef struct _TPLST_0rule_4* _TPPLST_0rule_4;
typedef struct _TPLST_0rule_5* _TPPLST_0rule_5;
typedef struct _TPLST_0rule_7* _TPPLST_0rule_7;
typedef struct _TPLST_0rule_9* _TPPLST_0rule_9;
typedef struct _TPLST_0rule_11* _TPPLST_0rule_11;
typedef struct _TPLST_0rule_12* _TPPLST_0rule_12;

struct _TSCon
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSConProd
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATargcount;
DefTableKey _ATkey;
int _ATaxiom;
};

struct _TSConLHS
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATkey;
};

struct _TSConAlt
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
PTGNode _AT_const28;
};

struct _TSConElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATkey;
};

struct _TSConIdent
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATsym;
};

struct _TSConText
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATsym;
};

struct _TSAbs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSAbsProd
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATkey;
int _ATaxiom;
};

struct _TSAbsSignature
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _AT_const4;
tOilArgSig _ATargsig;
int _ATargcount;
};

struct _TSAbsLHS
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATkey;
};

struct _TSAbsElements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSAbsElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATkey;
};

struct _TSAbsAlts
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSAbsAlt
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATkey;
};

struct _TSBottomUpRule
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSMap
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSMapSymbol
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATkey;
};

struct _TSMapRule
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATntcount;
DefTableKey _ATkey;
};

struct _TSMapChains
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSMapMember
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATkey;
};

struct _TSMapMembers
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSMapProd
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSMapReorder
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSMapLHS
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSMapDelim
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSMapAlt
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSMapElement
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSMapReorderAlt
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSMapPosition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSMapText
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSSource
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
Environment _ATenv;
int _ATGotBottomUp;
int _ATAxiomCnt;
};

struct _TSBottomUpRules
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSG15
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_Con
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_ConAlt
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_Abs
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_AbsElements
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_AbsAlts
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_Map
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_MapMembers
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_MapAlt
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST_MapReorderAlt
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPpConProd
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATargcount;
DefTableKey _ATkey;
int _ATaxiom;
_TSPConLHS _desc1;
_TSPConAlt _desc2;
POSITION _AT_pos;
};

struct _TPpConLHS
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATkey;
_TSPConIdent _desc1;
POSITION _AT_pos;
};

struct _TPpConIdnElt
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATkey;
_TSPConIdent _desc1;
};

struct _TPpConTextElt
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATkey;
_TSPConText _desc1;
};

struct _TPpConActionElt
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATkey;
_TSPConText _desc1;
};

struct _TPpConAtModIdn
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATkey;
_TSPConIdent _desc1;
};

struct _TPpConAtModTxt
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATkey;
_TSPConText _desc1;
};

struct _TPpConDollarModIdn
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATkey;
_TSPConIdent _desc1;
};

struct _TPpConDollarModTxt
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATkey;
_TSPConText _desc1;
};

struct _TPpConIdent
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATsym;
};

struct _TPpConText
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATsym;
};

struct _TPpAbsProd
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATkey;
int _ATaxiom;
_TSPAbsSignature _desc1;
int _ATTERM_1;
};

struct _TPpAbsLHS
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATkey;
POSITION _AT_pos;
int _ATTERM_1;
};

struct _TPpAbsEmptyRule
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _AT_const4;
tOilArgSig _ATargsig;
int _ATargcount;
_TSPAbsLHS _desc1;
};

struct _TPpAbsRule
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _AT_const4;
tOilArgSig _ATargsig;
int _ATargcount;
_TSPAbsLHS _desc1;
_TSPAbsElements _desc2;
};

struct _TPpAbsEltIdn
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATkey;
int _ATTERM_1;
};

struct _TPpAbsEltTxt
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATkey;
int _ATTERM_1;
};

struct _TPpAbsEltGen
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATkey;
int _ATTERM_1;
};

struct _TPpAbsListof
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _AT_const4;
tOilArgSig _ATargsig;
int _ATargcount;
_TSPAbsLHS _desc1;
_TSPAbsAlts _desc2;
POSITION _AT_pos;
};

struct _TPpAbsAltIdn
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATkey;
int _ATTERM_1;
};

struct _TPpMapSymbol
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATkey;
_TSPMapMembers _desc1;
POSITION _AT_pos;
int _ATTERM_1;
};

struct _TPpMapProdReorder
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATntcount;
DefTableKey _ATkey;
_TSPMapProd _desc1;
_TSPMapReorder _desc2;
POSITION _AT_pos;
};

struct _TPpMapProd
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPMapLHS _desc1;
_TSPMapDelim _desc2;
_TSPMapAlt _desc3;
POSITION _AT_pos;
};

struct _TPpMapIdnElt
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
POSITION _AT_pos;
int _ATTERM_1;
};

struct _TPpMapTextElt
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
POSITION _AT_pos;
int _ATTERM_1;
};

struct _TPpMapReorder
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPMapReorderAlt _desc1;
};

struct _TPpMapPosition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
POSITION _AT_pos;
int _ATTERM_1;
};

struct _TPpMapText
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _ATTERM_1;
};

struct _TPrule_000
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
Environment _ATenv;
int _ATGotBottomUp;
int _ATAxiomCnt;
};

struct _TPrule_001
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
Environment _ATenv;
int _ATGotBottomUp;
int _ATAxiomCnt;
_TSPBottomUpRules _desc1;
};

struct _TPrule_002
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
Environment _ATenv;
int _ATGotBottomUp;
int _ATAxiomCnt;
_TSPMap _desc1;
};

struct _TPrule_003
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
Environment _ATenv;
int _ATGotBottomUp;
int _ATAxiomCnt;
_TSPMap _desc1;
_TSPBottomUpRules _desc2;
};

struct _TPrule_004
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
Environment _ATenv;
int _ATGotBottomUp;
int _ATAxiomCnt;
_TSPAbs _desc1;
};

struct _TPrule_005
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
Environment _ATenv;
int _ATGotBottomUp;
int _ATAxiomCnt;
_TSPAbs _desc1;
_TSPBottomUpRules _desc2;
};

struct _TPrule_006
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
Environment _ATenv;
int _ATGotBottomUp;
int _ATAxiomCnt;
_TSPAbs _desc1;
_TSPMap _desc2;
};

struct _TPrule_007
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
Environment _ATenv;
int _ATGotBottomUp;
int _ATAxiomCnt;
_TSPAbs _desc1;
_TSPMap _desc2;
_TSPBottomUpRules _desc3;
};

struct _TPrule_008
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
Environment _ATenv;
int _ATGotBottomUp;
int _ATAxiomCnt;
_TSPCon _desc1;
};

struct _TPrule_009
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
Environment _ATenv;
int _ATGotBottomUp;
int _ATAxiomCnt;
_TSPCon _desc1;
_TSPBottomUpRules _desc2;
};

struct _TPrule_010
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
Environment _ATenv;
int _ATGotBottomUp;
int _ATAxiomCnt;
_TSPCon _desc1;
_TSPMap _desc2;
};

struct _TPrule_011
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
Environment _ATenv;
int _ATGotBottomUp;
int _ATAxiomCnt;
_TSPCon _desc1;
_TSPMap _desc2;
_TSPBottomUpRules _desc3;
};

struct _TPrule_012
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
Environment _ATenv;
int _ATGotBottomUp;
int _ATAxiomCnt;
_TSPCon _desc1;
_TSPAbs _desc2;
};

struct _TPrule_013
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
Environment _ATenv;
int _ATGotBottomUp;
int _ATAxiomCnt;
_TSPCon _desc1;
_TSPAbs _desc2;
_TSPBottomUpRules _desc3;
};

struct _TPrule_014
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
Environment _ATenv;
int _ATGotBottomUp;
int _ATAxiomCnt;
_TSPCon _desc1;
_TSPAbs _desc2;
_TSPMap _desc3;
};

struct _TPrule_015
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
Environment _ATenv;
int _ATGotBottomUp;
int _ATAxiomCnt;
_TSPCon _desc1;
_TSPAbs _desc2;
_TSPMap _desc3;
_TSPBottomUpRules _desc4;
};

struct _TPrule_016
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_017
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_018
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG15 _desc1;
};

struct _TPrule_019
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPrule_020
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPG15 _desc1;
_TSPBottomUpRule _desc2;
};

struct _TPrule_1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_Con _desc1;
};

struct _TPrule_2
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
PTGNode _AT_const28;
_TSPLST_ConAlt _desc1;
};

struct _TPrule_3
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_Abs _desc1;
};

struct _TPrule_4
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_AbsElements _desc1;
};

struct _TPrule_5
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_AbsAlts _desc1;
};

struct _TPrule_6
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
POSITION _AT_pos;
int _ATTERM_1;
};

struct _TPrule_7
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_Map _desc1;
};

struct _TPrule_8
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
DefTableKey _ATkey;
POSITION _AT_pos;
int _ATTERM_1;
};

struct _TPrule_9
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_MapMembers _desc1;
};

struct _TPrule_10
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
POSITION _AT_pos;
int _ATTERM_1;
};

struct _TPrule_11
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_MapAlt _desc1;
};

struct _TPrule_12
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPLST_MapReorderAlt _desc1;
};

struct _TPrule_13
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPLST_ConProdrule_1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPConProd _desc1;
_TSPLST_Con _desc2;
};

struct _TPLST_ConElementrule_2
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPConElement _desc1;
_TSPLST_ConAlt _desc2;
};

struct _TPLST_AbsProdrule_3
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPAbsProd _desc1;
_TSPLST_Abs _desc2;
};

struct _TPLST_AbsElementrule_4
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPAbsElement _desc1;
_TSPLST_AbsElements _desc2;
};

struct _TPLST_AbsAltrule_5
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPAbsAlt _desc1;
_TSPLST_AbsAlts _desc2;
};

struct _TPLST_MapSymbolrule_7
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPMapSymbol _desc1;
_TSPLST_Map _desc2;
};

struct _TPLST_MapRulerule_7
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPMapRule _desc1;
_TSPLST_Map _desc2;
};

struct _TPLST_MapChainsrule_7
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPMapChains _desc1;
_TSPLST_Map _desc2;
};

struct _TPLST_MapMemberrule_9
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPMapMember _desc1;
_TSPLST_MapMembers _desc2;
};

struct _TPLST_MapElementrule_11
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPMapElement _desc1;
_TSPLST_MapAlt _desc2;
};

struct _TPLST_MapPositionrule_12
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPMapPosition _desc1;
_TSPLST_MapReorderAlt _desc2;
};

struct _TPLST_MapTextrule_12
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPMapText _desc1;
_TSPLST_MapReorderAlt _desc2;
};

struct _TPLST_0rule_1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0rule_2
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0rule_3
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0rule_4
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0rule_5
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0rule_7
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0rule_9
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0rule_11
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0rule_12
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

#undef _NODECOMMON
#endif
