
#include "tp_gen.h"
#define NODEPTR_TYPE TPNode
#define OP_LABEL(p) ((p)->op)
#define LEFT_CHILD(p) ((p)->left)
#define RIGHT_CHILD(p) ((p)->right)
#define STATE_LABEL(p) ((p)->state_label)
#define PANIC printf
#ifdef MONITOR
#define COORD(p) ((p)->loc)
#else
#define COORD(p) NoPosition
#endif
#ifndef TP_PANIC
#define TP_PANIC	PANIC
#endif /* TP_PANIC */
#ifdef __STDC__
extern void abort(void);
#else
extern void abort();
#endif
#ifdef NDEBUG
#define TP_assert(x,y)	;
#else
#define TP_assert(x,y)	if(!(x)) {y; abort();}
#endif
static short TP_r1_nts[] ={ 2, 0 };
static short TP_r5_nts[] ={ 0 };
static short TP_r8_nts[] ={ 2, 2, 0 };
static short TP_r10_nts[] ={ 1, 0 };
short *TP_nts[] = {
	0,
	TP_r1_nts,
	TP_r1_nts,
	TP_r1_nts,
	TP_r1_nts,
	TP_r5_nts,
	TP_r5_nts,
	TP_r1_nts,
	TP_r8_nts,
	TP_r8_nts,
	TP_r10_nts,
};
static unsigned char TP_alt_transition[2][2] = {
{    0,    0}	/* row 0 */,
{    0,    1}	/* row 1 */
};
static unsigned char TP_seq_transition[2][2] = {
{    0,    0}	/* row 0 */,
{    0,    1}	/* row 1 */
};
static struct {
	unsigned int f0:2;
	unsigned int f1:3;
	unsigned int f2:3;
} TP_plank_0[] = {
	{   0,   0,   0,},	/* row 0 */
	{   1,   3,   1,},	/* row 1 */
	{   1,   1,   4,},	/* row 2 */
	{   1,   5,   1,},	/* row 3 */
	{   1,   6,   1,},	/* row 4 */
	{   1,   4,   1,},	/* row 5 */
	{   1,   1,   3,},	/* row 6 */
	{   1,   1,   2,},	/* row 7 */
	{   1,   2,   1,},	/* row 8 */
};
static short TP_eruleMap[] = {
    0,   10,    9,    8,    7,    6,    5,    0,    4,    3,	/* 0-9 */
    2,    1
};
#define TP_Name_rule(state)	TP_eruleMap[TP_plank_0[state].f2 +7]
#define TP_Expr_rule(state)	TP_eruleMap[TP_plank_0[state].f1 +0]

#ifdef __STDC__
int TP_rule(int state, int goalnt) {
#else
int TP_rule(state, goalnt) int state; int goalnt; {
#endif
	TP_assert(state >= 0 && state < 9, TP_PANIC("Bad state %d passed to TP_rule\n", state));
	switch(goalnt) {
	case 1:
		return TP_Name_rule(state);
	case 2:
		return TP_Expr_rule(state);
	default:
		TP_PANIC("Unknown nonterminal %d in TP_rule;\n", goalnt);
		abort();
		return 0;
	}
}

int TP_TEMP;
#define TP_ast_state(l)	( (TP_TEMP = TP_plank_0[l].f0) ? TP_TEMP + 1 : 0 )
#define TP_pls_state(l)	( (TP_TEMP = TP_plank_0[l].f0) ? TP_TEMP + 5 : 0 )
#define TP_sep_state(l)	( (TP_TEMP = TP_plank_0[l].f0) ? TP_TEMP + 6 : 0 )
#define TP_nul_state	4
#define TP_ato_state	3
#define TP_opt_state(l)	( (TP_TEMP = TP_plank_0[l].f0) ? TP_TEMP + 4 : 0 )
#define TP_alt_state(l,r)	( (TP_TEMP = TP_alt_transition[TP_plank_0[l].f0][TP_plank_0[r].f0]) ? TP_TEMP + 0 : 0 )
#define TP_seq_state(l,r)	( (TP_TEMP = TP_seq_transition[TP_plank_0[l].f0][TP_plank_0[r].f0]) ? TP_TEMP + 7 : 0 )

#ifdef __STDC__
int TP_state(int op, int l, int r) {
#else
int TP_state(op, l, r) int op; int l; int r; {
#endif
	register int TP_TEMP;
#ifndef NDEBUG
	switch (op) {
	case 7:
	case 8:
		TP_assert(r >= 0 && r < 9, TP_PANIC("Bad state %d passed to TP_state\n", r));
		/*FALLTHROUGH*/
	case 1:
	case 2:
	case 3:
	case 6:
		TP_assert(l >= 0 && l < 9, TP_PANIC("Bad state %d passed to TP_state\n", l));
		/*FALLTHROUGH*/
	case 4:
	case 5:
		break;
	}
#endif
	switch (op) {
	default: TP_PANIC("Unknown op %d in TP_state\n", op); abort(); return 0;
	case 1:
		return TP_ast_state(l);
	case 2:
		return TP_pls_state(l);
	case 3:
		return TP_sep_state(l);
	case 4:
		return TP_nul_state;
	case 5:
		return TP_ato_state;
	case 6:
		return TP_opt_state(l);
	case 7:
		return TP_alt_state(l,r);
	case 8:
		return TP_seq_state(l,r);
	}
}
#ifdef TP_STATE_LABEL
#define TP_INCLUDE_EXTRA
#else
#ifdef STATE_LABEL
#define TP_INCLUDE_EXTRA
#define TP_STATE_LABEL 	STATE_LABEL
#define TP_NODEPTR_TYPE	NODEPTR_TYPE
#define TP_LEFT_CHILD  	LEFT_CHILD
#define TP_OP_LABEL    	OP_LABEL
#define TP_RIGHT_CHILD 	RIGHT_CHILD
#endif /* STATE_LABEL */
#endif /* TP_STATE_LABEL */

#ifdef TP_INCLUDE_EXTRA

#ifdef __STDC__
int TP_label(TP_NODEPTR_TYPE n) {
#else
int TP_label(n) TP_NODEPTR_TYPE n; {
#endif
	TP_assert(n, TP_PANIC("NULL pointer passed to TP_label\n"));
	switch (TP_OP_LABEL(n)) {
	default: TP_PANIC("Bad op %d in TP_label\n", TP_OP_LABEL(n)); abort(); return 0;
	case 4:
	case 5:
		return TP_STATE_LABEL(n) = TP_state(TP_OP_LABEL(n), 0, 0);
	case 1:
	case 2:
	case 3:
	case 6:
		return TP_STATE_LABEL(n) = TP_state(TP_OP_LABEL(n), TP_label(TP_LEFT_CHILD(n)), 0);
	case 7:
	case 8:
		return TP_STATE_LABEL(n) = TP_state(TP_OP_LABEL(n), TP_label(TP_LEFT_CHILD(n)), TP_label(TP_RIGHT_CHILD(n)));
	}
}
#ifdef __STDC__
TP_NODEPTR_TYPE * TP_kids(TP_NODEPTR_TYPE p, int rulenumber, TP_NODEPTR_TYPE *kids) {
#else
TP_NODEPTR_TYPE * TP_kids(p, rulenumber, kids) TP_NODEPTR_TYPE p; int rulenumber; TP_NODEPTR_TYPE *kids; {
#endif
	TP_assert(p, TP_PANIC("NULL node pointer passed to TP_kids\n"));
	TP_assert(kids, TP_PANIC("NULL kids pointer passed to TP_kids\n"));
	switch (rulenumber) {
	default:
		TP_PANIC("Unknown Rule %d in TP_kids;\n", rulenumber);
		abort();
		/* NOTREACHED */
	case 5:
	case 6:
		break;
	case 1:
	case 2:
	case 3:
	case 7:
		kids[0] = TP_LEFT_CHILD(p);
		break;
	case 8:
	case 9:
		kids[0] = TP_LEFT_CHILD(p);
		kids[1] = TP_RIGHT_CHILD(p);
		break;
	case 4:
	case 10:
		kids[0] = p;
		break;
	}
	return kids;
}
#ifdef __STDC__
TP_NODEPTR_TYPE TP_child(TP_NODEPTR_TYPE p, int index) {
#else
TP_NODEPTR_TYPE TP_child(p, index) TP_NODEPTR_TYPE p; int index; {
#endif
	TP_assert(p, TP_PANIC("NULL pointer passed to TP_child\n"));
	switch (index) {
	case 0:
		return TP_LEFT_CHILD(p);
	case 1:
		return TP_RIGHT_CHILD(p);
	}
	TP_PANIC("Bad index %d in TP_child;\n", index);
	abort();
	return 0;
}
#ifdef __STDC__
int TP_op_label(TP_NODEPTR_TYPE p) {
#else
int TP_op_label(p) TP_NODEPTR_TYPE p; {
#endif
	TP_assert(p, TP_PANIC("NULL pointer passed to TP_op_label\n"));
	return TP_OP_LABEL(p);
}
#ifdef __STDC__
int TP_state_label(TP_NODEPTR_TYPE p) {
#else
int TP_state_label(p) TP_NODEPTR_TYPE p; {
#endif
	TP_assert(p, TP_PANIC("NULL pointer passed to TP_state_label\n"));
	return TP_STATE_LABEL(p);
}
#endif /* TP_INCLUDE_EXTRA */
#define TP_Expr_NT 2
#define TP_Name_NT 1
#define TP_NT 2
char * TP_opname[] = {
	0, /* 0 */
	"ast", /* 1 */
	"pls", /* 2 */
	"sep", /* 3 */
	"nul", /* 4 */
	"ato", /* 5 */
	"opt", /* 6 */
	"alt", /* 7 */
	"seq"
};
char TP_arity[] = {
	-1, /* 0 */
	1, /* 1 */
	1, /* 2 */
	1, /* 3 */
	0, /* 4 */
	0, /* 5 */
	1, /* 6 */
	2, /* 7 */
	2
};
int TP_max_op = 8;
int TP_max_state = 8;
#define TP_Max_state 8
char *TP_string[] = {
	0,
	"Name: ast(Expr)",
	"Name: pls(Expr)",
	"Name: sep(Expr)",
	"Name: Expr",
	"Expr: nul",
	"Expr: ato",
	"Expr: opt(Expr)",
	"Expr: alt(Expr, Expr)",
	"Expr: seq(Expr, Expr)",
	"Expr: Name",
};
int TP_max_rule = 10;
#define TP_Max_rule 10
short TP_rule_descriptor_0[] = { 0, 1 };
short TP_rule_descriptor_1[] = {   -1,    1,   -2, };
short TP_rule_descriptor_2[] = {   -1,    2,   -2, };
short TP_rule_descriptor_3[] = {   -1,    3,   -2, };
short TP_rule_descriptor_4[] = {   -1,   -2, };
short TP_rule_descriptor_5[] = {   -2,    4, };
short TP_rule_descriptor_6[] = {   -2,    5, };
short TP_rule_descriptor_7[] = {   -2,    6,   -2, };
short TP_rule_descriptor_8[] = {   -2,    7,   -2,   -2, };
short TP_rule_descriptor_9[] = {   -2,    8,   -2,   -2, };
short TP_rule_descriptor_10[] = {   -2,   -1, };
/* TP_rule_descriptors[0][1] = 1 iff grammar is normal form. */
short * TP_rule_descriptors[] = {
	TP_rule_descriptor_0,
	TP_rule_descriptor_1,
	TP_rule_descriptor_2,
	TP_rule_descriptor_3,
	TP_rule_descriptor_4,
	TP_rule_descriptor_5,
	TP_rule_descriptor_6,
	TP_rule_descriptor_7,
	TP_rule_descriptor_8,
	TP_rule_descriptor_9,
	TP_rule_descriptor_10,
};
short TP_cost[][4] = {
	{    0,    0,    0,    0}, /* (none) = 0 */
	{    1,    0,    0,    0}, /* Name: ast(Expr) = 1 */
	{    1,    0,    0,    0}, /* Name: pls(Expr) = 2 */
	{    1,    0,    0,    0}, /* Name: sep(Expr) = 3 */
	{    1,    0,    0,    0}, /* Name: Expr = 4 */
	{    1,    0,    0,    0}, /* Expr: nul = 5 */
	{    1,    0,    0,    0}, /* Expr: ato = 6 */
	{    1,    0,    0,    0}, /* Expr: opt(Expr) = 7 */
	{    1,    0,    0,    0}, /* Expr: alt(Expr, Expr) = 8 */
	{    1,    0,    0,    0}, /* Expr: seq(Expr, Expr) = 9 */
	{    1,    0,    0,    0}, /* Expr: Name = 10 */
};

short TP_delta_cost[9][3][4] = {
{{0}}, /* state 0 */
{ /* state #1: alt(ato, ato) */
	{0},
	{    1,    0,    0,    0}, /* Name: Expr = 4 */
	{    0,    0,    0,    0}, /* Expr: alt(Expr, Expr) = 8 */
},
{ /* state #2: ast(ato) */
	{0},
	{    0,    0,    0,    0}, /* Name: ast(Expr) = 1 */
	{    1,    0,    0,    0}, /* Expr: Name = 10 */
},
{ /* state #3: ato */
	{0},
	{    1,    0,    0,    0}, /* Name: Expr = 4 */
	{    0,    0,    0,    0}, /* Expr: ato = 6 */
},
{ /* state #4: nul */
	{0},
	{    1,    0,    0,    0}, /* Name: Expr = 4 */
	{    0,    0,    0,    0}, /* Expr: nul = 5 */
},
{ /* state #5: opt(ato) */
	{0},
	{    1,    0,    0,    0}, /* Name: Expr = 4 */
	{    0,    0,    0,    0}, /* Expr: opt(Expr) = 7 */
},
{ /* state #6: pls(ato) */
	{0},
	{    0,    0,    0,    0}, /* Name: pls(Expr) = 2 */
	{    1,    0,    0,    0}, /* Expr: Name = 10 */
},
{ /* state #7: sep(ato) */
	{0},
	{    0,    0,    0,    0}, /* Name: sep(Expr) = 3 */
	{    1,    0,    0,    0}, /* Expr: Name = 10 */
},
{ /* state #8: seq(ato, ato) */
	{0},
	{    1,    0,    0,    0}, /* Name: Expr = 4 */
	{    0,    0,    0,    0}, /* Expr: seq(Expr, Expr) = 9 */
},
};

char * TP_state_string[] = {
" not a state", /* state 0 */
	"alt(ato, ato)", /* state #1 */
	"ast(ato)", /* state #2 */
	"ato", /* state #3 */
	"nul", /* state #4 */
	"opt(ato)", /* state #5 */
	"pls(ato)", /* state #6 */
	"sep(ato)", /* state #7 */
	"seq(ato, ato)", /* state #8 */
};
char *TP_ntname[] = {
	"Error: Nonterminals are > 0",
	"Name",
	"Expr",
	0
};

short TP_closure[3][3] = {
	{    0,    0,    0,},
	{    0,    0,    4,},
	{    0,   10,    0,},
};


#include "csm.h"
#include "obstack.h"

static Obstack obstk;
static ObstackP scaffold = (ObstackP)0;

static int HasError = 0;

void
TP_init()
{ scaffold = &obstk; obstack_init(scaffold); }

#ifdef MONITOR
TPNode
#ifdef PROTO_OK
TPCoord(TPNode node, CoordPtr coord)
#else
TPCoord(node, coord) TPNode node; CoordPtr coord;
#endif
{
  node->loc = coord;
  return node; }
#endif

static void
#ifdef PROTO_OK
BuildError(TPNode node)
#else
BuildError(node) TPNode node;
#endif
{ char *msg;
  int badkids = 0;
  obstack_grow(Csm_obstk, "No rule matches \"", 18);
  obstack_strgrow(Csm_obstk, TP_opname[OP_LABEL(node)]);
  obstack_1grow(Csm_obstk, '(');
  if (TP_arity[OP_LABEL(node)] > 0) {
    if (!STATE_LABEL(LEFT_CHILD(node))) badkids++;
    obstack_strgrow(Csm_obstk, TP_opname[OP_LABEL(LEFT_CHILD(node))]);
  }
  if (TP_arity[OP_LABEL(node)] > 1) {
    if (!STATE_LABEL(RIGHT_CHILD(node))) badkids++;
    obstack_1grow(Csm_obstk, ',');
    obstack_strgrow(Csm_obstk, TP_opname[OP_LABEL(RIGHT_CHILD(node))]);
  }
  msg = obstack_copy0(Csm_obstk, ")\"", 3);
  if (badkids) obstack_free(Csm_obstk, msg);
  else message(ERROR, msg, 0, COORD(node));
  HasError++;
}

static void
#ifdef PROTO_OK
ReduceError(TPNode p, int goalnt)
#else
ReduceError(p, goalnt) TPNode p; int goalnt;
#endif
{ if (HasError == 0 && !STATE_LABEL(p)) BuildError(p);
  if (HasError > 0)
    message(DEADLY,"Can't parse a tree with errors",0,COORD(p));
  obstack_grow(Csm_obstk, "No \"", 5);
  obstack_strgrow(Csm_obstk, TP_opname[p->op]);
  obstack_1grow(Csm_obstk, '(');
  if (TP_arity[p->op] > 0)
    obstack_strgrow(Csm_obstk, TP_opname[p->left->op]);
  if (TP_arity[p->op] > 1) {
    obstack_1grow(Csm_obstk, ',');
    obstack_strgrow(Csm_obstk, TP_opname[p->right->op]);
  }
  obstack_grow(Csm_obstk, ")\" rule builds ", 16);
  message(DEADLY,
    obstack_strcpy(Csm_obstk, TP_ntname[goalnt]),
    0,
    COORD(p));
}

struct TP_1 {
#ifdef MONITOR
  CoordPtr loc;
#endif
  int op, state_label; TPNode left; 
};

TPNode
#ifdef PROTO_OK
TP_1(int op, TPNode left)
#else
TP_1(op, left) int op; TPNode left; 
#endif
{ struct TP_1 temp;

  if (TP_arity[op] != 1) {
    obstack_strgrow(Csm_obstk, TP_opname[op]);
    message(DEADLY,
      obstack_copy0(Csm_obstk, " used with arity 1", 18),
      0,
      NoPosition);
  }
  if (!STATE_LABEL(left)) BuildError(left);
  temp.op = op;
  temp.state_label = TP_state(op, STATE_LABEL(left), 0);
  temp.left = left;
#ifdef MONITOR
  temp.loc = NoPosition;
#endif
  return (TPNode)obstack_copy(scaffold, &temp, sizeof(temp));
}

struct TP_1_PTGNode {
#ifdef MONITOR
  CoordPtr loc;
#endif
  int op, state_label; TPNode left; PTGNode f_0; 
};

TPNode
#ifdef PROTO_OK
TP_1_PTGNode(int op, TPNode left, PTGNode f_0)
#else
TP_1_PTGNode(op, left, f_0) int op; TPNode left; PTGNode f_0; 
#endif
{ struct TP_1_PTGNode temp;

  if (TP_arity[op] != 1) {
    obstack_strgrow(Csm_obstk, TP_opname[op]);
    message(DEADLY,
      obstack_copy0(Csm_obstk, " used with arity 1", 18),
      0,
      NoPosition);
  }
  if (!STATE_LABEL(left)) BuildError(left);
  temp.op = op;
  temp.state_label = TP_state(op, STATE_LABEL(left), 0);
  temp.left = left;
#ifdef MONITOR
  temp.loc = NoPosition;
#endif
  temp.f_0=f_0;
  return (TPNode)obstack_copy(scaffold, &temp, sizeof(temp));
}

struct TP_0 {
#ifdef MONITOR
  CoordPtr loc;
#endif
  int op, state_label; 
};

TPNode
#ifdef PROTO_OK
TP_0(int op)
#else
TP_0(op) int op; 
#endif
{ struct TP_0 temp;

  if (TP_arity[op] != 0) {
    obstack_strgrow(Csm_obstk, TP_opname[op]);
    message(DEADLY,
      obstack_copy0(Csm_obstk, " used with arity 0", 18),
      0,
      NoPosition);
  }
  temp.op = op;
  temp.state_label = TP_state(op, 0, 0);
#ifdef MONITOR
  temp.loc = NoPosition;
#endif
  return (TPNode)obstack_copy(scaffold, &temp, sizeof(temp));
}

struct TP_0_PTGNode {
#ifdef MONITOR
  CoordPtr loc;
#endif
  int op, state_label; PTGNode f_0; 
};

TPNode
#ifdef PROTO_OK
TP_0_PTGNode(int op, PTGNode f_0)
#else
TP_0_PTGNode(op, f_0) int op; PTGNode f_0; 
#endif
{ struct TP_0_PTGNode temp;

  if (TP_arity[op] != 0) {
    obstack_strgrow(Csm_obstk, TP_opname[op]);
    message(DEADLY,
      obstack_copy0(Csm_obstk, " used with arity 0", 18),
      0,
      NoPosition);
  }
  temp.op = op;
  temp.state_label = TP_state(op, 0, 0);
#ifdef MONITOR
  temp.loc = NoPosition;
#endif
  temp.f_0=f_0;
  return (TPNode)obstack_copy(scaffold, &temp, sizeof(temp));
}

struct TP_2 {
#ifdef MONITOR
  CoordPtr loc;
#endif
  int op, state_label; TPNode left, right; 
};

TPNode
#ifdef PROTO_OK
TP_2(int op, TPNode left, TPNode right)
#else
TP_2(op, left, right) int op; TPNode left, right; 
#endif
{ struct TP_2 temp;

  if (TP_arity[op] != 2) {
    obstack_strgrow(Csm_obstk, TP_opname[op]);
    message(DEADLY,
      obstack_copy0(Csm_obstk, " used with arity 2", 18),
      0,
      NoPosition);
  }
  if (!STATE_LABEL(left)) BuildError(left);
  if (!STATE_LABEL(right)) BuildError(right);
  temp.op = op;
  temp.state_label = TP_state(op,STATE_LABEL(left),STATE_LABEL(right));
  temp.left = left;
  temp.right = right;
#ifdef MONITOR
  temp.loc = NoPosition;
#endif
  return (TPNode)obstack_copy(scaffold, &temp, sizeof(temp));
}

static NODEPTR Reduce_NODEPTR ELI_ARG((TPNode p, int goalnt));

static NODEPTR
#ifdef PROTO_OK
Reduce_NODEPTR(TPNode p, int goalnt)
#else
Reduce_NODEPTR(p, goalnt) TPNode p; int goalnt;
#endif
{ int eruleno = TP_rule(STATE_LABEL(p), goalnt);
  short *nts = TP_nts[eruleno];
  TPNode kids[10];

  if (!eruleno) ReduceError(p, goalnt);
  TP_kids(p, eruleno, kids);

  switch (eruleno) {
  case 1: return MK_astr(Reduce_NODEPTR(kids[0],nts[0]));
  case 2: return MK_plus(Reduce_NODEPTR(kids[0],nts[0]));
  case 3: return MK_sepr(Reduce_NODEPTR(kids[0],nts[0]), ((struct TP_1_PTGNode *)p)->f_0);
  case 4: return MK_dist(Reduce_NODEPTR(kids[0],nts[0]));
  case 5: return MK_null();
  case 6: return MK_atom(((struct TP_0_PTGNode *)p)->f_0);
  case 7: return MK_optn(Reduce_NODEPTR(kids[0],nts[0]));
  case 8: return MK_altn(Reduce_NODEPTR(kids[0],nts[0]), Reduce_NODEPTR(kids[1],nts[1]));
  case 9: return MK_seqn(Reduce_NODEPTR(kids[0],nts[0]), Reduce_NODEPTR(kids[1],nts[1]));
  case 10: return MK_gens(Reduce_NODEPTR(kids[0],nts[0]));
  default: message(DEADLY,"Invalid reduction",6,NoPosition);
  }
}

NODEPTR
#ifdef PROTO_OK
TP_Name(TPNode p)
#else
TP_Name(p) TPNode p;
#endif
{ return Reduce_NODEPTR(p, TP_Name_NT); }

NODEPTR
#ifdef PROTO_OK
TP_Expr(TPNode p)
#else
TP_Expr(p) TPNode p;
#endif
{ return Reduce_NODEPTR(p, TP_Expr_NT); }

