#define NONLITCOUNT 7
#define LITCOUNT 10
#define NTOKENS 17
#define EOFTOKEN 1
#if defined(__cplusplus) || defined(__STDC__)
extern void mkidn(char *, int, int *, int *),
 mkidn(char *, int, int *, int *),
 dummy1(char *, int, int *, int *);
#else
extern void mkidn(),
 mkidn(),
 dummy1();
#endif
#if defined(__cplusplus) || defined(__STDC__)
extern char *auxPascalString(char *, int),
 *auxEOL(char *, int),
 *auxEOL(char *, int),
 *dummy2(char *, int);
#else
extern char *auxPascalString(),
 *auxEOL(),
 *auxEOL(),
 *dummy2();
#endif
#ifdef MONITOR
int mon_nonlit_codes[] = {
 10,
 16,
 11,
 5,
 2,
 15001,
 15001,
 -1
};
char *mon_token_names[] = {
 "Identifier",
 "Literal",
 "Is",
 "Or",
 "Sep",
 "",
 "",
 ""
};
#endif

static short CaseTbl[128] = {
  0,  0,  0,  0,  0,  0,  0,  0,     /*   0.  1.  2.  3.  4.  5.  6.  7. */
  0,  2,  3,  0,  0,  4,  0,  0,     /*   8.  9. 10. 11. 12. 13. 14. 15. */
  0,  0,  0,  0,  0,  0,  0,  0,     /*  16. 17. 18. 19. 20. 21. 22. 23. */
  0,  0,  0,  0,  0,  0,  0,  0,     /*  24. 25. 26. 27. 28. 29. 30. 31. */
  1,  0,  0, 11, 12, 10, 12,  9,     /*  32. ! " # $ % & ' */
 12, 12, 12, 12,  0,  0, 12,  8,     /*  ( ) * + , - . / */
  0,  0,  0,  0,  0,  0,  0,  0,     /*  0 1 2 3 4 5 6 7 */
  0,  0,  7,  0,  0,  0,  0,  0,     /*  8 9 : ; < = > ? */
 12,  5,  5,  5,  5,  5,  5,  5,     /*  @ A B C D E F G */
  5,  5,  5,  5,  5,  5,  5,  5,     /*  H I J K L M N O */
  5,  5,  5,  5,  5,  5,  5,  5,     /*  P Q R S T U V W */
  5,  5,  5, 12,  0, 12,  0,  5,     /*  X Y Z [ \ ] ^ _ */
  0,  5,  5,  5,  5,  5,  5,  5,     /*  ` a b c d e f g */
  5,  5,  5,  5,  5,  5,  5,  5,     /*  h i j k l m n o */
  5,  5,  5,  5,  5,  5,  5,  5,     /*  p q r s t u v w */
  5,  5,  5,  0,  6,  0,  0,  0};    /*  x y z { | } ~ 127. */

static short ExtCodeTbl[128] = {
  0,  0,  0,  0,  0,  0,  0,  0,     /*   0.  1.  2.  3.  4.  5.  6.  7. */
  0,  0,  0,  0,  0,  0,  0,  0,     /*   8.  9. 10. 11. 12. 13. 14. 15. */
  0,  0,  0,  0,  0,  0,  0,  0,     /*  16. 17. 18. 19. 20. 21. 22. 23. */
  0,  0,  0,  0,  0,  0,  0,  0,     /*  24. 25. 26. 27. 28. 29. 30. 31. */
  0,  0,  0,  0, 14,  0, 15,  0,     /*  32. ! " # $ % & ' */
  6,  7,  3,  4,  0,  0, 12,  0,     /*  ( ) * + , - . / */
  0,  0,  0,  0,  0,  0,  0,  0,     /*  0 1 2 3 4 5 6 7 */
  0,  0,  0,  0,  0,  0,  0,  0,     /*  8 9 : ; < = > ? */
 13,  0,  0,  0,  0,  0,  0,  0,     /*  @ A B C D E F G */
  0,  0,  0,  0,  0,  0,  0,  0,     /*  H I J K L M N O */
  0,  0,  0,  0,  0,  0,  0,  0,     /*  P Q R S T U V W */
  0,  0,  0,  8,  0,  9,  0,  0,     /*  X Y Z [ \ ] ^ _ */
  0,  0,  0,  0,  0,  0,  0,  0,     /*  ` a b c d e f g */
  0,  0,  0,  0,  0,  0,  0,  0,     /*  h i j k l m n o */
  0,  0,  0,  0,  0,  0,  0,  0,     /*  p q r s t u v w */
  0,  0,  0,  0,  0,  0,  0,  0};    /*  x y z { | } ~ 127. */
static unsigned char ScanTbl[] = {
0x00, 0x00, 0x00, 0x00,	/*   0.   1.   2.   3. */
0x00, 0x00, 0x00, 0x00,	/*   4.   5.   6.   7. */
0x00, 0x02, 0x04, 0x00,	/*   8.   9.  10.  11. */
0x00, 0x00, 0x00, 0x00,	/*  12.  13.  14.  15. */
0x00, 0x00, 0x00, 0x00,	/*  16.  17.  18.  19. */
0x00, 0x00, 0x00, 0x00,	/*  20.  21.  22.  23. */
0x00, 0x00, 0x00, 0x00,	/*  24.  25.  26.  27. */
0x00, 0x00, 0x00, 0x00,	/*  28.  29.  30.  31. */
0x01, 0x00, 0x00, 0x00,	/*  32.  !  "  # */
0x00, 0x00, 0x00, 0x00,	/*  $  %  &  ' */
0x00, 0x00, 0x00, 0x00,	/*  (  )  *  + */
0x00, 0x00, 0x00, 0x00,	/*  ,  -  .  / */
0x08, 0x08, 0x08, 0x08,	/*  0  1  2  3 */
0x08, 0x08, 0x08, 0x08,	/*  4  5  6  7 */
0x08, 0x08, 0x00, 0x00,	/*  8  9  :  ; */
0x00, 0x00, 0x00, 0x00,	/*  <  =  >  ? */
0x00, 0x08, 0x08, 0x08,	/*  @  A  B  C */
0x08, 0x08, 0x08, 0x08,	/*  D  E  F  G */
0x08, 0x08, 0x08, 0x08,	/*  H  I  J  K */
0x08, 0x08, 0x08, 0x08,	/*  L  M  N  O */
0x08, 0x08, 0x08, 0x08,	/*  P  Q  R  S */
0x08, 0x08, 0x08, 0x08,	/*  T  U  V  W */
0x08, 0x08, 0x08, 0x00,	/*  X  Y  Z  [ */
0x00, 0x00, 0x00, 0x08,	/*  \  ]  ^  _ */
0x00, 0x08, 0x08, 0x08,	/*  `  a  b  c */
0x08, 0x08, 0x08, 0x08,	/*  d  e  f  g */
0x08, 0x08, 0x08, 0x08,	/*  h  i  j  k */
0x08, 0x08, 0x08, 0x08,	/*  l  m  n  o */
0x08, 0x08, 0x08, 0x08,	/*  p  q  r  s */
0x08, 0x08, 0x08, 0x08,	/*  t  u  v  w */
0x08, 0x08, 0x08, 0x00,	/*  x  y  z  { */
0x00, 0x00, 0x00, 0x00 }; /*  |  }  ~  127. */
